/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <netdb.h>  */

#ifndef _NETDB_H
#define _NETDB_H	1


/*
 * Structures returned by network
 * data base library.  All addresses
 * are supplied in host order, and
 * returned in network order (suitable
 * for use in system calls).
 */
struct	hostent {
	char	*h_name;	/* official name of host */
	char	**h_aliases;	/* alias list */
	int	h_addrtype;	/* host address type */
	int	h_length;	/* length of address */
	char	**h_addr_list;	/* address */
#define h_addr h_addr_list[0]
};

/*
 * Assumption here is that a network number
 * fits in 32 bits -- probably a poor one.
 */
struct	netent {
	char	*n_name;	/* official name of net */
	char	**n_aliases;	/* alias list */
	int	n_addrtype;	/* net address type */
	int	n_net;		/* network # */
};

struct	servent {
	char	*s_name;	/* official service name */
	char	**s_aliases;	/* alias list */
	int	s_port;		/* port # */
	char	*s_proto;	/* protocol to use */
};

struct	protoent {
	char	*p_name;	/* official protocol name */
	char	**p_aliases;	/* alias list */
	int	p_proto;	/* protocol # */
};

struct rpcent {
	char    *r_name;        /* name of server for this rpc program */
	char    **r_aliases;    /* alias list */
	int     r_number;       /* rpc program number */
};

struct hostent *gethostbyaddr( char *addr, int len, int type) __asm ("DECC$GETHOSTBYADDR");
struct hostent *gethostbyname( char *name) __asm ("DECC$GETHOSTBYNAME");
struct hostent *gethostent() __asm ("DECC$GETHOSTENT");
struct netent *getnetbyaddr( long net, int type) __asm ("DECC$GETNETBYADDR");
struct netent *getnetbyname( char *name) __asm ("DECC$GETNETBYNAME");
struct netent *getnetent() __asm ("DECC$GETNETENT");
struct servent *getservbyname( char *name, char *proto) __asm ("DECC$GETSERVBYNAME");
struct servent *getservbyport(int port, char *proto) __asm ("DECC$GETSERVBYPORT");
struct servent *getservent() __asm ("DECC$GETSERVENT");
struct protoent	*getprotobyname(char *name) __asm ("DECC$GETPROTOBYNAME");
struct protoent	*getprotobynumber(int proto) __asm ("DECC$GETPROTOBYNUMBER");
struct protoent	*getprotoent() __asm ("DECC$GETPROTOENT");

#endif					/* _NETDB_H */
