/* <sys/types.h>
 *
 *	This is the UNIX-compatible sys/types definition.
 */
#ifndef _SYS_TYPES_H
#define _SYS_TYPES_H

#define _TYPES_		/* old indicator */
#define __TYPES__

#ifndef _TIME_T
# ifndef _TYPES_H
#  define _TYPES_H
/* note: this is not even remotely the same as <sys/types.h> */

#  if !defined(_TIME_T) && !defined(_TIME_T_)
typedef unsigned long long time_t;
#  endif
#  define _TIME_T
#  define _TIME_T_

# endif  /*_TYPES_H*/
#endif

/*
 * Basic system types
 */

typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned int	u_int;
typedef unsigned int	u_int32;
typedef unsigned long	u_long;

#if !defined(_USHORT_T) && !defined(_USHORT_T_)
typedef unsigned short	ushort;		/* sys III compat */
#endif
#define _USHORT_T
#define _USHORT_T_

#ifndef _QUAD_T
# define _QUAD_T
# ifdef __ALPHA
typedef long long quad;
# else
typedef struct	_quad { long val[2]; } quad;
# endif
#endif

typedef long	daddr_t;

#if !defined(_CADDR_T) && !defined(_CADDR_T_) && !defined(CADDR_T)
typedef char   *caddr_t;
#endif
#define _CADDR_T
#define _CADDR_T_
#define CADDR_T
#define __CADDR_T 1	/* this one's for decwindows */

#if !defined(_INO_T) && !defined(_INO_T_)
# ifdef FIXED_INO_T
 /* use a definition that makes sense for VMS ODS-2; <stat.h> must cooperate */
typedef struct { unsigned short : 16, : 16, : 16; } ino_t __attribute__ ((packed));
# else
 /* use a definition that's compatible with VAXC's broken one; array[3] used */
typedef u_short ino_t;
# endif
#endif
#define _INO_T
#define _INO_T_

typedef long	swblk_t;

#if !defined(_SIZE_T) && !defined(_SIZE_T_)
typedef unsigned long size_t;
#endif
#define _SIZE_T
#define _SIZE_T_
#if !defined(_DEV_T) && !defined(_DEV_T_)
typedef short dev_t;
#endif
#define _DEV_T
#define _DEV_T_
#if !defined(_OFF_T) && !defined(_OFF_T_)
typedef unsigned off_t;
#endif
#define _OFF_T
#define _OFF_T_
#if !defined(_UID_T) && !defined(_UID_T_)
#if __ALPHA
typedef unsigned long uid_t;
#else
typedef u_short uid_t;
#endif
#define _UID_T
#define _UID_T_
#endif
#if !defined(_GID_T) && !defined(_GID_T_)
typedef unsigned short gid_t;
#define _GID_T
#define _GID_T_
#endif
#if !defined(_PID_T) && !defined(_PID_T_)
typedef unsigned int pid_t;
#define _PID_T
#define _PID_T_
#endif

#if !defined(_PTR_T) && !defined(_PTR_T_)
typedef void * __ptr_t;
#define _PTR_T
#define _PTR_T_
#endif

#ifndef _MODE_T_
typedef unsigned short mode_t;
#define _MODE_T
#define _MODE_T_
#endif

#ifdef _Xt_Intrinsic_h		/* (see <X11/Intrinsic.h>) */
#define MAX(a,b) (((a)<(b))?(a):(b))
#define MIN(a,b) (((a)>(b))?(a):(b))
#endif

#ifndef __P
#if __STDC__
#define __P(x) x
#else
#define __P(x)
#endif
#endif

#endif	/*_SYS_TYPES_H*/
