/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <lib$routines.h>
 *
 *	General run-time library routines.
 */
#ifndef _CLI$ROUTINES_H
#define _CLI$ROUTINES_H
# ifdef __cplusplus
extern "C" {
# endif

/* Command Language Interpreter (CLI) Routines
   CLI$DCL_PARSE - Parse DCL command string
   status = CLI$DCL_PARSE ([command_string], table [,param_routine]
  	[,prompt_routine] [,prompt_string])
    command_string - Command string to parse
    table   - Command table
    param_routine  - Routine to obtain omitted parameters
    prompt_routine - Routine to prompt for input
    prompt_string  - Prompt string for display	*/

#define cli$dcl_parse CLI$DCL_PARSE
unsigned int cli$dcl_parse();

/* CLI$DISPATCH - Dispatch to action routine
   status = CLI$DISPATCH ([userarg])
    userarg - User argument	*/

#define cli$dispatch CLI$DISPATCH
unsigned int cli$dispatch();

/* CLI$GET_VALUE - Get value of entity in command string
   status = CLI$GET_VALUE (entity_desc, retdesc [, retlength])
    entity_desc - Entity to retrieve
    retdesc	- Returned value string
    retlength	- Length of returned value	*/

#define cli$get_value CLI$GET_VALUE
unsigned int cli$get_value();

/* CLI$PRESENT - Determine presence of entity in command string
   status = CLI$PRESENT (entity_desc)
    entity_desc - Entity to retrieve	*/

#define cli$present CLI$PRESENT
unsigned int cli$present();

# ifdef __cplusplus
}
# endif
#endif	/*_CLI$ROUTINES_H*/
