/* <credef.h>
 *
 *	LBRUSR -- Create options table
 */
#ifndef _CREDEF_H
#define _CREDEF_H

#define CRE$C_VMSV2	2	/* VMS version V04-000 format */
#define CRE$C_VMSV3	3	/* VMS version 3 format */
#define CRE$V_NOCASECMP 0
#define CRE$V_NOCASENTR 1
#define CRE$V_UPCASNTRY 2
#define CRE$M_NOCASECMP (1<<CRE$V_NOCASECMP)	/* 0x01 */
#define CRE$M_NOCASENTR (1<<CRE$V_NOCASENTR)	/* 0x02 */
#define CRE$M_UPCASNTRY (1<<CRE$V_UPCASNTRY)	/* 0x04 */
#define CRE$C_HLPCASING 6	/* treat upper casing as it is for HELP libs */
#define CRE$C_OBJCASING 3	/* treat upper casing as it is for OBJECT libs */
#define CRE$C_MACTXTCAS 0	/* treat upper casing as it is for MACRO and TEXT libs */
#define CRE$K_LENGTH	80
#define CRE$C_LENGTH	80

struct credef {
    unsigned long cre$l_type;		/* type of library (library types defined in $LBRDEF) */
    unsigned long cre$l_keylen;		/* length of keys in library */
    unsigned long cre$l_alloc;		/* initial file allocation */
    unsigned long cre$l_idxmax;		/* maximum number of indices */
    unsigned long cre$l_uhdmax;		/* size of additional module header data */
    unsigned long cre$l_entall;		/* number of index entries to pre-allocate */
    unsigned long cre$l_luhmax;		/* number of library update history records to store */
    unsigned long cre$l_vertyp;		/* version type of library to create */
    union {
	unsigned long cre$l_idxopt;	/* index options */
	struct {
	    unsigned cre$v_nocasecmp : 1; /* do not upper case the match key */
	    unsigned cre$v_nocasentr : 1; /* do not upper case the index key when comparing with a match key */
	    unsigned cre$v_upcasntry : 1; /* upper case the index key when entering it into the library */
	    unsigned		     : 5;
	} cre$r_idxopt_bits;
    } cre$r_idxopt_overlay;
    long credef_fill[11];		/* reserved 11 longwords */
};

#endif	/*_CREDEF_H*/
