/* <vms/lib/ctlp1flagsdef.h>
 *
 *	CTL P1 flags	[not in Starlet]
 */
#ifndef _CTLP1FLAGSDEF_H
#define _CTLP1FLAGSDEF_H
/*
   These are flags in the CTL p1 region to define miscellaneous things.
   They reside in the cell CTL$GQ_MISC_P1_FLAGS, defined in SHELL.MAR.
 */
#define CTLP1FLAGS$V_GSD_CLEAN	    0
#define CTLP1FLAGS$V_IPC_CLEAN	    1
#define CTLP1FLAGS$V_PSX_PML	    2
#define CTLP1FLAGS$V_PSX_PML_ERROR  3
#define CTLP1FLAGS$V_KSTK_EXPANDED  4
#define CTLP1FLAGS$M_GSD_CLEAN	    (1<<CTLP1FLAGS$V_GSD_CLEAN)     /* 0x01 */
#define CTLP1FLAGS$M_IPC_CLEAN	    (1<<CTLP1FLAGS$V_IPC_CLEAN)     /* 0x02 */
#define CTLP1FLAGS$M_PSX_PML	    (1<<CTLP1FLAGS$V_PSX_PML)	    /* 0x04 */
#define CTLP1FLAGS$M_PSX_PML_ERROR  (1<<CTLP1FLAGS$V_PSX_PML_ERROR) /* 0x08 */
#define CTLP1FLAGS$M_KSTK_EXPANDED  (1<<CTLP1FLAGS$V_KSTK_EXPANDED) /* 0x10 */

struct ctlp1def {
    unsigned ctlp1flags$v_gsd_clean : 1;	/* GSD clean-up is in progress */
    unsigned ctlp1flags$v_ipc_clean : 1;	/* $IPC association clean-up is in progress */
    unsigned ctlp1flags$v_psx_pml   : 1;	/* POSIX dynamic memory locking requested */
    unsigned ctlp1flags$v_psx_pml_error : 1;	/* POSIX dynamic memory locking error */
    unsigned ctlp1flags$v_kstk_expanded : 1;	/* mark mounts expansion of kernel stack */
    unsigned			    : 3;
};

#endif	/*_CTLP1FLAGSDEF_H*/
