/* <dstdef.h>
 *
 *	Debug command stream constants (for descriptor DTYPE_CAD)
 */
#ifndef _DSTDEF_H
#define _DSTDEF_H

#define DST$K_LOCOMMAND 0	/* low value for range checking */
#define DST$K_STA_R00	0	/* stack contents of R0 */
#define DST$K_STA_R01	1	/* stack contents of R1 */
#define DST$K_STA_R02	2	/* stack contents of R2 */
#define DST$K_STA_R03	3	/* stack contents of R3 */
#define DST$K_STA_R04	4	/* stack contents of R4 */
#define DST$K_STA_R05	5	/* stack contents of R5 */
#define DST$K_STA_R06	6	/* stack contents of R6 */
#define DST$K_STA_R07	7	/* stack contents of R7 */
#define DST$K_STA_R08	8	/* stack contents of R8 */
#define DST$K_STA_R09	9	/* stack contents of R9 */
#define DST$K_STA_R10	10	/* stack contents of R10 */
#define DST$K_STA_R11	11	/* stack contents of R11 */
#define DST$K_STA_R12	12	/* stack contents of R12 (AP) */
#define DST$K_STA_R13	13	/* stack contents of R13 (FP) */
#define DST$K_STA_R14	14	/* stack contents of R14 (SP) */
#define DST$K_STA_R15	15	/* stack contents of R15 (PC) */
#define DST$K_STA_IMM_B 16	/* stack contents of byte operand sign extending to longword */
#define DST$K_STA_IMM_W 17	/* stack contents of word operand sign extending to longword */
#define DST$K_STA_IMM_L 18	/* stack contents of longword operand */
#define DST$K_OPR_ADD	19	/* pop two operands, add, stack longword result */
#define DST$K_STA_REP_B 20	/* pop top item and stack sign extended byte at that address */
#define DST$K_STA_REP_W 21	/* pop top item and stack sign extended word at that address */
#define DST$K_STA_REP_L 22	/* pop top item and stack longword at that address */
#define DST$K_OPR_STOP	23	/* terminate command string. Longword at top */
				/*  of stack contains address of data item.  */
#define DST$K_HICOMMAND 23	/* hi value for range checking */

#endif	/*_DSTDEF_H*/
