/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <dtk$routines.h>
 *
 *	DECtalk run-time library routines.
 */
#ifndef _DTK$ROUTINES_H
#define _DTK$ROUTINES_H
# ifdef __cplusplus
extern "C" {
# endif

/*	DTK$ANSWER_PHONE	-- wait for phone to ring and answer */
#define dtk$answer_phone DTK$ANSWER_PHONE
unsigned long dtk$answer_phone(const unsigned long *,...);
/*	DTK$CHECK_HDWR_STATUS	-- check hardware status */
#define dtk$check_hdwr_status DTK$CHECK_HDWR_STATUS
unsigned long dtk$check_hdwr_status(const unsigned long *,unsigned long *);
/*	DTK$DIAL_PHONE		-- dial the telephone */
#define dtk$dial_phone DTK$DIAL_PHONE
unsigned long dtk$dial_phone(const unsigned long *,const void *,...);
/*	DTK$HANGUP_PHONE	-- hang up the phone */
#define dtk$hangup_phone DTK$HANGUP_PHONE
unsigned long dtk$hangup_phone(const unsigned long *,...);
/*	DTK$INITIALIZE		-- initialize DECtalk */
#define dtk$initialize DTK$INITIALIZE
unsigned long dtk$initialize(unsigned long *,const void *,...);
/*	DTK$LOAD_DICTIONARY	-- load a word into the DECtalk dictionary */
#define dtk$load_dictionary DTK$LOAD_DICTIONARY
unsigned long dtk$load_dictionary(const unsigned long *,const void *,const void *);
/*	DTK$READ_KEYSTROKE	-- read a key entered on the keypad */
#define dtk$read_keystroke DTK$READ_KEYSTROKE
unsigned long dtk$read_keystroke(const unsigned long *,unsigned long *,...);
/*	DTK$READ_STRING		-- read a series of keys entered on keypad */
#define dtk$read_string DTK$READ_STRING
unsigned long dtk$read_string(const unsigned long *,void *,...);
/*	DTK$RETURN_LAST_INDEX	-- return last index spoken */
#define dtk$return_last_index DTK$RETURN_LAST_INDEX
unsigned long dtk$return_last_index(const unsigned long *,long *);
/*	DTK$SET_INDEX		-- insert an index at the current position */
#define dtk$set_index DTK$SET_INDEX
unsigned long dtk$set_index(const unsigned long *,const long *);
/*	DTK$SET_KEYPAD_MODE	-- turn the phone keypad on and off */
#define dtk$set_keypad_mode DTK$SET_KEYPAD_MODE
unsigned long dtk$set_keypad_mode(const unsigned long *,const unsigned long *);
/*	DTK$SET_LOGGING_MODE	-- set logging mode for attached video terminal */
#define dtk$set_logging_mode DTK$SET_LOGGING_MODE
unsigned long dtk$set_logging_mode(const unsigned long *,...);
/*	DTK$SET_MODE		-- set the mode for the DECtalk terminal */
#define dtk$set_mode DTK$SET_MODE
unsigned long dtk$set_mode(const unsigned long *,...);
/*	DTK$SET_SPEECH_MODE	-- turn speech mode on and off */
#define dtk$set_speech_mode DTK$SET_SPEECH_MODE
unsigned long dtk$set_speech_mode(const unsigned long *,...);
/*	DTK$SET_TERMINAL_MODE	-- set the mode for attached video terminal */
#define dtk$set_terminal_mode DTK$SET_TERMINAL_MODE
unsigned long dtk$set_terminal_mode(const unsigned long *,...);
/*	DTK$SET_VOICE		-- set voice characteristics */
#define dtk$set_voice DTK$SET_VOICE
unsigned long dtk$set_voice(const unsigned long *,...);
/*	DTK$SPEAK_FILE		-- speak the text in a specified file */
#define dtk$speak_file DTK$SPEAK_FILE
unsigned long dtk$speak_file(const unsigned long *,const void *,...);
/*	DTK$SPEAK_PHONEMIC_TEXT -- speak the specified phonemic text */
#define dtk$speak_phonemic_text DTK$SPEAK_PHONEMIC_TEXT
unsigned long dtk$speak_phonemic_text(const unsigned long *,const void *,...);
/*	DTK$SPEAK_TEXT		-- speak the specified text */
#define dtk$speak_text DTK$SPEAK_TEXT
unsigned long dtk$speak_text(const unsigned long *,const void *,...);
/*	DTK$SPELL_TEXT		-- spell text */
#define dtk$spell_text DTK$SPELL_TEXT
unsigned long dtk$spell_text(const unsigned long *,const void *,...);
/*	DTK$TERMINATE		-- terminate DECtalk */
#define dtk$terminate DTK$TERMINATE
unsigned long dtk$terminate(const unsigned long *);

# ifdef __cplusplus
}
# endif
#endif	/*_DTK$ROUTINES_H*/
