/* <egsydef.h>
 *
 *	OBJFMT -- "EVAX" GSD entry - Symbol definition
 */
#ifndef _EGSYDEF_H
#define _EGSYDEF_H

/* common to definitions, references, and entry point definitions. */
#define EGSY$V_WEAK	0
#define EGSY$V_DEF	1
#define EGSY$V_UNI	2
#define EGSY$V_REL	3
#define EGSY$V_COMM	4
#define EGSY$V_VECEP	5
#define EGSY$V_NORM	6
#define EGSY$M_WEAK	(1<<EGSY$V_WEAK)	/* 0x01 */
#define EGSY$M_DEF	(1<<EGSY$V_DEF)		/* 0x02 */
#define EGSY$M_UNI	(1<<EGSY$V_UNI)		/* 0x04 */
#define EGSY$M_REL	(1<<EGSY$V_REL)		/* 0x08 */
#define EGSY$M_COMM	(1<<EGSY$V_COMM)	/* 0x10 */
#define EGSY$M_VECEP	(1<<EGSY$V_VECEP)	/* 0x20 */
#define EGSY$M_NORM	(1<<EGSY$V_NORM)	/* 0x40 */
struct egsydef {
    unsigned short egsy$w_gsdtyp;	/* type field */
    unsigned short egsy$w_size;		/* size of this EGSY */
    unsigned char egsy$b_datyp;		/* symbol data type */
    unsigned char egsy$b_temp;		/* pad for alignment */
    union {
	unsigned short egsy$w_flags;	/* symbol flags */
	struct {
	    unsigned egsy$v_weak  : 1;	/* weak symbol */
	    unsigned egsy$v_def   : 1;	/* definition */
	    unsigned egsy$v_uni   : 1;	/* universal */
	    unsigned egsy$v_rel   : 1;	/* relocatable */
	    unsigned egsy$v_comm  : 1;	/* C common globaldef */
	    unsigned egsy$v_vecep : 1;	/* vectored entry point */
	    unsigned egsy$v_norm  : 1;	/* normal procedure(FD) */
	    unsigned		  : 1;
	    unsigned		  : 8;
	} egsy$r_flags_bits;
    } egsy$r_flags_overlay;
};

#endif	/*_EGSYDEF_H*/
