/* <emhdef.h>
 *
 *	OBJFMT -- "EVAX" module header record (MHD)
 */
#ifndef _EMHDEF_H
#define _EMHDEF_H

/* types of header records */
#define EMH$C_MHD	0	/* main header record */
#define EMH$C_LNM	1	/* language name and version */
#define EMH$C_SRC	2	/* source file specification */
#define EMH$C_TTL	3	/* title text of module */
#define EMH$C_CPR	4	/* copyright notice */
#define EMH$C_MTC	5	/* maintenence status */
#define EMH$C_GTX	6	/* general text */
#define EMH$C_MAXHDRTYP 6	/* maximum allowable type */

struct emhdef {
    unsigned short emh$w_rectyp;	/* record type (OBJ$C_MHD) */
    unsigned short emh$w_size;		/* length of this EMH */
    unsigned short emh$w_hdrtyp;	/* type field for MHD */
    unsigned char emh$b_strlvl;		/* structure level */
    unsigned char emh$b_temp;		/* temp pad byte */
    long emh$l_arch1;			/* target architecture LW1 */
    long emh$l_arch2;			/* target architecture LW2 */
    unsigned long emh$l_recsiz;		/* maximum record size */
    unsigned char emh$b_namlng;		/* module name length */
    char emh$t_name[31];		/* module name */
};

#endif	/*_EMHDEF_H*/
