/* <vms/lib/fh2def.h>
 *
 *	F11DEF - file header structure, ODS level 2	[not in Starlet]
 */
#ifndef _FH2DEF_H
#define _FH2DEF_H

#define FH2$C_LEVEL1	257	/* 401 octal = structure level 1 */
#define FH2$C_LEVEL2	512	/* 1000 octal = structure level 2 */
/* file characteristics "chunks" */
#define FH2$V_VCC_STATE 8
#define FH2$M_VCC_STATE 0x0700
#define FH2$S_VCC_STATE 3
#define FH2$V_ALM_STATE 18
#define FH2$M_ALM_STATE 0x0C0000
#define FH2$S_ALM_STATE 2
/* file characteristics bits */
#define FH2$V_WASCONTIG 0
#define FH2$V_NOBACKUP	1
#define FH2$V_WRITEBACK 2
#define FH2$V_READCHECK 3
#define FH2$V_WRITCHECK 4
#define FH2$V_CONTIGB	5
#define FH2$V_LOCKED	6
#define FH2$V_CONTIG	7
#define FH2$V_BADACL	11
#define FH2$V_SPOOL	12
#define FH2$V_DIRECTORY 13
#define FH2$V_BADBLOCK	14
#define FH2$V_MARKDEL	15
#define FH2$V_NOCHARGE	16
#define FH2$V_ERASE	17
#define FH2$V_ALM_AIP	18
#define FH2$V_SHELVED	19
#define FH2$V_ALM_ARCHIVED 19
#define FH2$V_SCRATCH	20
#define FH2$V_NOMOVE	21
#define FH2$V_NOSHELVABLE 22
#define FH2$V_SHELVING_RESERVED 23
#define FH2$M_WASCONTIG (1<<FH2$V_WASCONTIG)	/* 0x01 */
#define FH2$M_NOBACKUP	(1<<FH2$V_NOBACKUP)	/* 0x02 */
#define FH2$M_WRITEBACK (1<<FH2$V_WRITEBACK)	/* 0x04 */
#define FH2$M_READCHECK (1<<FH2$V_READCHECK)	/* 0x08 */
#define FH2$M_WRITCHECK (1<<FH2$V_WRITCHECK)	/* 0x10 */
#define FH2$M_CONTIGB	(1<<FH2$V_CONTIGB)	/* 0x20 */
#define FH2$M_LOCKED	(1<<FH2$V_LOCKED)	/* 0x40 */
#define FH2$M_CONTIG	(1<<FH2$V_CONTIG)	/* 0x80 */
#define FH2$M_BADACL	(1<<FH2$V_BADACL)	/* 0x0800 */
#define FH2$M_SPOOL	(1<<FH2$V_SPOOL)	/* 0x1000 */
#define FH2$M_DIRECTORY (1<<FH2$V_DIRECTORY)	/* 0x2000 */
#define FH2$M_BADBLOCK	(1<<FH2$V_BADBLOCK)	/* 0x4000 */
#define FH2$M_MARKDEL	(1<<FH2$V_MARKDEL)	/* 0x8000 */
#define FH2$M_NOCHARGE	(1<<FH2$V_NOCHARGE)	/* 0x010000 */
#define FH2$M_ERASE	(1<<FH2$V_ERASE)	/* 0x020000 */
#define FH2$M_ALM_AIP	(1<<FH2$V_ALM_AIP)	/* 0x040000 */
#define FH2$M_SHELVED	(1<<FH2$V_SHELVED)	/* 0x080000 */
#define FH2$M_ALM_ARCHIVED (1<<FH2$V_ALM_ARCHIVED) /* 0x080000 */
#define FH2$M_SCRATCH	(1<<FH2$V_SCRATCH)	/* 0x100000 */
#define FH2$M_NOMOVE	(1<<FH2$V_NOMOVE)	/* 0x200000 */
#define FH2$M_NOSHELVABLE (1<<FH2$V_NOSHELVABLE) /* 0x400000 */
#define FH2$M_SHELVING_RESERVED (1<<FH2$V_SHELVING_RESERVED) /* 0x800000 */
/* journalling bits */
#define FH2$V_ONLY_RU	0
#define FH2$V_RUJNL	1
#define FH2$V_BIJNL	2
#define FH2$V_AIJNL	3
#define FH2$V_ATJNL	4
#define FH2$V_NEVER_RU	5
#define FH2$V_JOURNAL_FILE 6
#define FH2$M_ONLY_RU	(1<<FH2$V_ONLY_RU)	/* 0x01 */
#define FH2$M_RUJNL	(1<<FH2$V_RUJNL)	/* 0x02 */
#define FH2$M_BIJNL	(1<<FH2$V_BIJNL)	/* 0x04 */
#define FH2$M_AIJNL	(1<<FH2$V_AIJNL)	/* 0x08 */
#define FH2$M_ATJNL	(1<<FH2$V_ATJNL)	/* 0x10 */
#define FH2$M_NEVER_RU	(1<<FH2$V_NEVER_RU)	/* 0x20 */
#define FH2$M_JOURNAL_FILE (1<<FH2$V_JOURNAL_FILE) /* 0x40 */
/* recovery unit facility codes */
#define FH2$C_RU_FACILITY_RMS	1	/* RMS */
#define FH2$C_RU_FACILITY_DBMS	2	/* DBMS */
#define FH2$C_RU_FACILITY_RDB	3	/* Rdb/VMS */
#define FH2$C_RU_FACILITY_CHKPNT 4	/* Checkpoint/Restart */
/* size constants */
#define FH2$S_FID	6
#define FH2$S_EXT_FID	6
#define FH2$S_BACKLINK	6
#define FH2$S_RECATTR	32
#define FH2$S_CLASS_PROT 20
#define FH2$K_LENGTH		80	/* length of header area */
#define FH2$C_LENGTH		80
#define FH2$K_SUBSET0_LENGTH	88	/* length of header area */
#define FH2$C_SUBSET0_LENGTH	88
#define FH2$K_FULL_LENGTH	108	/* length of full header */
#define FH2$C_FULL_LENGTH	108
#define FH2$S_FH2DEF	512
struct fh2def {
    unsigned char fh2$b_idoffset;	/* ident area offset in words */
    unsigned char fh2$b_mpoffset;	/* map area offset in words */
    unsigned char fh2$b_acoffset;	/* access control list offset in words */
    unsigned char fh2$b_rsoffset;	/* reserved area offset in words */
    unsigned short fh2$w_seg_num;	/* file segment number */
    union {
	unsigned short fh2$w_struclev;		/* file structure level */
	struct {
	    unsigned char fh2$b_strucver;	/* file structure version */
	    unsigned char fh2$b_struclev;	/* principal file structure level */
	} fh2$r_struclev_fields;
    } fh2$r_struclev_overlay;
    union {
	unsigned short fh2$w_fid[3];		/* file ID */
	struct {
	    unsigned short fh2$w_fid_num;	/* file number */
	    unsigned short fh2$w_fid_seq;	/* file sequence number */
	    union {
		unsigned short fh2$w_fid_rvn;	/* relative volume number */
		struct {
		    unsigned char fh2$b_fid_rvn; /* alternate format RVN */
		    unsigned char fh2$b_fid_nmx; /* alternate format file number extension */
		} fh2$r_fid_rvn_fields;
	    } fh2$r_fid_rvn_overlay;
	} fh2$r_fid_fields;
    } fh2$r_fid_overlay;
    union {
	unsigned short fh2$w_ext_fid[3];	/* extension file ID */
	struct {
	    unsigned short fh2$w_ex_fidnum;	/* extension file number */
	    unsigned short fh2$w_ex_fidseq;	/* extension file sequence number */
	    union {
		unsigned short fh2$w_ex_fidrvn; /* extension relative volume number */
		struct {
		    unsigned char fh2$b_ex_fidrvn; /* alternate format extension RVN */
		    unsigned char fh2$b_ex_fidnmx; /* alternate format extension file number extension */
		} fh2$r_ex_fidrvn_fields;
	    } fh2$r_ex_fidrvn_overlay;
	} fh2$r_ext_fid_fields;
    } fh2$r_ext_fid_overlay;
    unsigned short fh2$w_recattr[16];	/* file record attributes */
    union {
	unsigned long fh2$l_filechar;	/* file characteristics */
	struct {
	    unsigned			: 8;
	    unsigned fh2$v_vcc_state	: 3; /* VCC state bits */
	    unsigned			: 7;
		/* the following field is omitted from $FCHDEF */
	    unsigned fh2$v_alm_state	: 2; /* ALM state bits [was 3] */
	    unsigned			: 4;
	    unsigned			: 8;
	} fh2$r_filechar_chunks;
	struct {
	    unsigned fh2$v_wascontig	: 1; /* file was (and should be) contiguous */
	    unsigned fh2$v_nobackup	: 1; /* file is not to be backed up */
	    unsigned fh2$v_writeback	: 1; /* file may be write-back cached */
	    unsigned fh2$v_readcheck	: 1; /* verify all read operations */
	    unsigned fh2$v_writcheck	: 1; /* verify all write operations */
	    unsigned fh2$v_contigb	: 1; /* keep file as contiguous as possible */
	    unsigned fh2$v_locked	: 1; /* file is deaccess locked */
	    unsigned fh2$v_contig	: 1; /* file is contiguous */
	    unsigned			: 3; /* reserved */
	    unsigned fh2$v_badacl	: 1; /* ACL is invalid */
	    unsigned fh2$v_spool	: 1; /* intermediate spool file */
	    unsigned fh2$v_directory	: 1; /* file is a directory */
	    unsigned fh2$v_badblock	: 1; /* file contains bad blocks */
	    unsigned fh2$v_markdel	: 1; /* file is marked for delete */
	    unsigned fh2$v_nocharge	: 1; /* file space is not to be charged */
	    unsigned fh2$v_erase	: 1; /* erase file contents before deletion */
		/* the following field is different from $FCHDEF */
	    unsigned fh2$v_alm_aip	: 1; /* archive in progress - ALM proj cancelled */
	    unsigned fh2$v_shelved	: 1; /* file is shelved */
#define fh2$v_alm_archived fh2$v_shelved     /* file archived - ALM proj cancelled */
	    unsigned fh2$v_scratch	: 1; /* scratch header used by movefile */
#define fh2$v_alm_deleted fh2$v_scratch
	    unsigned fh2$v_nomove	: 1; /* disable movefile on this file */
	    unsigned fh2$v_noshelvable	: 1; /* file is not allowed to be shelved */
	    unsigned fh2$v_shelving_reserved : 1; /* reserved for shelving facility */
	    unsigned			: 8; /* reserved for user & CSS */
	} fh2$r_filechar_bits;
    } fh2$r_filechar_overlay;
    unsigned short fh2$w_recprot;	/* record protection */
    unsigned char fh2$b_map_inuse;	/* number of map area words in use */
    unsigned char fh2$b_acc_mode;	/* least privileged access mode */
    union {
	unsigned long fh2$l_fileowner;		/* file owner UIC */
	struct {
	    unsigned short fh2$w_uicmember;	/* UIC member number */
	    unsigned short fh2$w_uicgroup;	/* UIC group number */
	} fh2$r_fileowner_fields;
    } fh2$r_fileowner_overlay;
    unsigned short fh2$w_fileprot;		/* file protection */
    union {
	unsigned short fh2$w_backlink[3];	/* back link pointer */
	struct {
	    unsigned short fh2$w_bk_fidnum;	/* back link file number */
	    unsigned short fh2$w_bk_fidseq;	/* back link file sequence number */
	    union {
		unsigned short fh2$w_bk_fidrvn; /* back link relative volume number */
		struct {
		    unsigned char fh2$b_bk_fidrvn; /* alternate format back link RVN */
		    unsigned char fh2$b_bk_fidnmx; /* alternate format back link file number extension */
		} fh2$r_bk_fidrvn_fields;
	    } fh2$r_bk_fidrvn_overlay;
	} fh2$r_backlink_fields;
    } fh2$r_backlink_overlay;
    union {
	unsigned char fh2$b_journal;		/* journal control flags */
	struct {
	    unsigned fh2$v_only_ru  : 1;	/* file is accessible only in recovery unit */
	    unsigned fh2$v_rujnl    : 1;	/* enable recovery unit journal */
	    unsigned fh2$v_bijnl    : 1;	/* enable before image journal */
	    unsigned fh2$v_aijnl    : 1;	/* enable after image journal */
	    unsigned fh2$v_atjnl    : 1;	/* enable audit trail journal */
	    unsigned fh2$v_never_ru : 1;	/* file is never accessible in recovery unit */
	    unsigned fh2$v_journal_file : 1;	/* this is a journal file */
	    unsigned		    : 1;	/* padding */
	} fh2$r_journal_bits;
    } fh2$r_journal_overlay;
    unsigned char fh2$b_ru_active;	/* If non-zero, file has active recovery units */
					/* (value is recoverable facility id number)   */
					/* 1-99 reserved to DEC, 100-127 reserved for  */
					/* CSS, 128-255 reserved for customers.        */
    unsigned	: 16;			/* reserved */
    unsigned long fh2$l_highwater;	/* high-water mark in file */
    unsigned	: 32, : 32;		/* reserver */
    struct {				/* security classification mask */
	char fh2$b_class_prot[20];	/* see structure in $CLSDEF */
    } fh2$r_class_prot;
    char fh2def$$b_fill[402];		/* rest of file header */
    unsigned short fh2$w_checksum;	/* file header checksum */
};

#endif	/*_FH2DEF_H*/
