/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <fibdef.h>
 *
 *	File Information Block definitions
 */
#ifndef _FIBDEF_H
#define _FIBDEF_H

/* layout of the file identification block (FIB) */

/* access control (acctl) bit mask values */
#define FIB$V_NOWRITE	0
#define FIB$V_DLOCK	1
#define FIB$V_BLK_LOCK	2
#define FIB$V_FASTRDSQNOS 3
#define FIB$V_SPOOL	4
#define FIB$V_WRITECK	5
#define FIB$V_SEQONLY	6
#define FIB$V_SEQNO	7
#define FIB$V_WRITE	8
#define FIB$V_READCK	9
#define FIB$V_NOREAD	10
#define FIB$V_NOTRUNC	11
#define FIB$V_CONTROL	12
#define FIB$V_NO_READ_DATA 13
#define FIB$V_EXECUTE	16
#define FIB$V_PRSRV_ATR 17
#define FIB$V_RMSLOCK	18
#define FIB$V_WRITETHRU 19
#define FIB$V_NOLOCK	20
#define FIB$V_NORECORD	21
#define FIB$V_NOVERIFY	22
#define FIB$V_CHANGE_VOL 23
#define FIB$M_NOWRITE	(1<<FIB$V_NOWRITE)	/* 0x01 */
#define FIB$M_DLOCK	(1<<FIB$V_DLOCK)	/* 0x02 */
#define FIB$M_BLK_LOCK	(1<<FIB$V_BLK_LOCK)	/* 0x04 */
#define FIB$M_FASTRDSQNOS (1<<FIB$V_FASTRDSQNOS) /* 0x08 */
#define FIB$M_SPOOL	(1<<FIB$V_SPOOL)	/* 0x10 */
#define FIB$M_WRITECK	(1<<FIB$V_WRITECK)	/* 0x20 */
#define FIB$M_SEQONLY	(1<<FIB$V_SEQONLY)	/* 0x40 */
#define FIB$M_SEQNO	(1<<FIB$V_SEQNO)	/* 0x80 */
#define FIB$M_WRITE	(1<<FIB$V_WRITE)	/* 0x0100 */
#define FIB$M_READCK	(1<<FIB$V_READCK)	/* 0x0200 */
#define FIB$M_NOREAD	(1<<FIB$V_NOREAD)	/* 0x0400 */
#define FIB$M_NOTRUNC	(1<<FIB$V_NOTRUNC)	/* 0x0800 */
#define FIB$M_CONTROL	(1<<FIB$V_CONTROL)	/* 0x1000 */
#define FIB$M_NO_READ_DATA (1<<FIB$V_NO_READ_DATA) /* 0x2000 */
#define FIB$M_EXECUTE	(1<<FIB$V_EXECUTE)	/* 0x010000 */
#define FIB$M_PRSRV_ATR (1<<FIB$V_PRSRV_ATR)	/* 0x020000 */
#define FIB$M_RMSLOCK	(1<<FIB$V_RMSLOCK)	/* 0x040000 */
#define FIB$M_WRITETHRU (1<<FIB$V_WRITETHRU)	/* 0x080000 */
#define FIB$M_NOLOCK	(1<<FIB$V_NOLOCK)	/* 0x100000 */
#define FIB$M_NORECORD	(1<<FIB$V_NORECORD)	/* 0x200000 */
#define FIB$M_NOVERIFY	(1<<FIB$V_NOVERIFY)	/* 0x400000 */
#define FIB$M_CHANGE_VOL (1<<FIB$V_CHANGE_VOL)	/* 0x800000 */
#define FIB$V_REWIND	3
#define FIB$V_CURPOS	4
#define FIB$V_UPDATE	6
#define FIB$M_REWIND	(1<<FIB$V_REWIND)	/* 0x08 */
#define FIB$M_CURPOS	(1<<FIB$V_CURPOS)	/* 0x10 */
#define FIB$M_UPDATE	(1<<FIB$V_UPDATE)	/* 0x40 */
#define FIB$K_ACCDATA	10	/* above data necessary for access */
#define FIB$C_ACCDATA	10
#define FIB$K_DIRDATA	22	/* above data necessary for directory ops */
#define FIB$C_DIRDATA	22
/* name control (nmctl) bit mask values */
#define FIB$V_ALLVER	3
#define FIB$V_ALLTYP	4
#define FIB$V_ALLNAM	5
#define FIB$V_WILD	8
#define FIB$V_NEWVER	9
#define FIB$V_SUPERSEDE 10
#define FIB$V_FINDFID	11
#define FIB$V_LOWVER	14
#define FIB$V_HIGHVER	15
#define FIB$M_ALLVER	(1<<FIB$V_ALLVER)	/* 0x08 */
#define FIB$M_ALLTYP	(1<<FIB$V_ALLTYP)	/* 0x10 */
#define FIB$M_ALLNAM	(1<<FIB$V_ALLNAM)	/* 0x20 */
#define FIB$M_WILD	(1<<FIB$V_WILD)		/* 0x0100 */
#define FIB$M_NEWVER	(1<<FIB$V_NEWVER)	/* 0x0200 */
#define FIB$M_SUPERSEDE (1<<FIB$V_SUPERSEDE)	/* 0x0400 */
#define FIB$M_FINDFID	(1<<FIB$V_FINDFID)	/* 0x0800 */
#define FIB$M_LOWVER	(1<<FIB$V_LOWVER)	/* 0x4000 */
#define FIB$M_HIGHVER	(1<<FIB$V_HIGHVER)	/* 0x8000 */
/* extend control (exctl) bit mask values */
#define FIB$V_ALCON	0
#define FIB$V_ALCONB	1
#define FIB$V_FILCON	2
#define FIB$V_ALDEF	3
#define FIB$V_ALLOCATR	4
#define FIB$V_EXTEND	7
#define FIB$V_TRUNC	8
#define FIB$V_NOHDREXT	9
#define FIB$V_MARKBAD	10
#define FIB$V_NOPLACE	14
#define FIB$V_NOCHARGE	15
#define FIB$M_ALCON	(1<<FIB$V_ALCON)	/* 0x01 */
#define FIB$M_ALCON	(1<<FIB$V_ALCON)	/* 0x01 */
#define FIB$M_ALCONB	(1<<FIB$V_ALCONB)	/* 0x02 */
#define FIB$M_FILCON	(1<<FIB$V_FILCON)	/* 0x04 */
#define FIB$M_ALDEF	(1<<FIB$V_ALDEF)	/* 0x08 */
#define FIB$M_ALLOCATR	(1<<FIB$V_ALLOCATR)	/* 0x10 */
#define FIB$M_EXTEND	(1<<FIB$V_EXTEND)	/* 0x80 */
#define FIB$M_TRUNC	(1<<FIB$V_TRUNC)	/* 0x0100 */
#define FIB$M_NOHDREXT	(1<<FIB$V_NOHDREXT)	/* 0x0200 */
#define FIB$M_MARKBAD	(1<<FIB$V_MARKBAD)	/* 0x0400 */
#define FIB$M_NOPLACE	(1<<FIB$V_NOPLACE)	/* 0x4000 */
#define FIB$M_NOCHARGE	(1<<FIB$V_NOCHARGE)	/* 0x8000 */
#define FIB$K_EXTDATA	32	/* above necessary for basic file extension */
#define FIB$C_EXTDATA	32
/* allocation options (alopts) bit mask values */
#define FIB$V_EXACT	0
#define FIB$V_ONCYL	1
#define FIB$M_EXACT	(1<<FIB$V_EXACT)	/* 0x01 */
#define FIB$M_ONCYL	(1<<FIB$V_ONCYL)	/* 0x02 */
#define FIB$C_CYL	1	/* cylinder address specified */
#define FIB$C_LBN	2	/* LBN specified */
#define FIB$C_VBN	3	/* proximate VBN specified */
#define FIB$C_RFI	4	/* related file id specified */
#define FIB$K_ALCDATA	44	/* above data necessary for placement */
#define FIB$C_ALCDATA	44
/* general status options (status) bit mask values */
#define FIB$V_ALT_REQ	   0
#define FIB$V_ALT_GRANTED  1
#define FIB$V_DIRACL	   2
#define FIB$V_PROPAGATE    3
#define FIB$V_NOCOPYACL    4
#define FIB$V_NOCOPYOWNER  5
#define FIB$V_NOCOPYPROT   6
#define FIB$V_EXCLPREVIOUS 7
#define FIB$V_ALIAS_ENTRY  8
#define FIB$V_WILDFID_FLAG 9
#define FIB$M_ALT_REQ	   (1<<FIB$V_ALT_REQ)	   /* 0x01 */
#define FIB$M_ALT_GRANTED  (1<<FIB$V_ALT_GRANTED)  /* 0x02 */
#define FIB$M_DIRACL	   (1<<FIB$V_DIRACL)	   /* 0x04 */
#define FIB$M_PROPAGATE    (1<<FIB$V_PROPAGATE)    /* 0x08 */
#define FIB$M_NOCOPYACL    (1<<FIB$V_NOCOPYACL)    /* 0x10 */
#define FIB$M_NOCOPYOWNER  (1<<FIB$V_NOCOPYOWNER)  /* 0x20 */
#define FIB$M_NOCOPYPROT   (1<<FIB$V_NOCOPYPROT)   /* 0x40 */
#define FIB$M_EXCLPREVIOUS (1<<FIB$V_EXCLPREVIOUS) /* 0x80 */
#define FIB$M_ALIAS_ENTRY  (1<<FIB$V_ALIAS_ENTRY)  /* 0x0100 */
#define FIB$M_WILDFID_FLAG (1<<FIB$V_WILDFID_FLAG) /* 0x0200 */
#define FIB$K_MOVEFILE	72	/* end of FIB required by MOVEFILE */
#define FIB$C_MOVEFILE	72
#ifndef NO_VMS_V6
#define FIB$K_LENGTH	80
#define FIB$C_LENGTH	80
#else
#define FIB$K_LENGTH	72
#define FIB$C_LENGTH	72
#endif
#define FIB$K_LENGTH_OLD 64	/* pre-V5.5 */
#define FIB$C_LENGTH_OLD 64

struct fibdef {
    union {
	unsigned long fib$l_acctl;	/* access control bits */
#define fib$l_acctl fib$r_acctl_overlay.fib$l_acctl
	struct {
	    unsigned fib$v_nowrite	: 1; /* no other writers */
	    unsigned fib$v_dlock	: 1; /* enable deaccess lock */
	    unsigned fib$v_blk_lock	: 1; /* enable RMS-11 block locking */
	    unsigned fib$v_fastrdsqnos	: 1; /* read hdrseq and dataseq vals */
	    unsigned fib$v_spool	: 1; /* spool file on close */
	    unsigned fib$v_writeck	: 1; /* enable write check */
	    unsigned fib$v_seqonly	: 1; /* sequential only access */
	    unsigned fib$v_seqno	: 1; /* store seqnos for this file */
	    unsigned fib$v_write	: 1; /* write access */
	    unsigned fib$v_readck	: 1; /* enable read check */
	    unsigned fib$v_noread	: 1; /* no other readers */
	    unsigned fib$v_notrunc	: 1; /* file may not be truncated */
	    unsigned fib$v_control	: 1; /* control access to file */
	    unsigned fib$v_no_read_data : 1; /* no read access to file data */
	    unsigned			: 2; /* spare */
 /* the high 8 bits cannot be copied into the access mode word in the window */
	    unsigned fib$v_execute	: 1; /* access for execute (use execute protection) */
	    unsigned fib$v_prsrv_atr	: 1; /* preserve original attributes of file */
	    unsigned fib$v_rmslock	: 1; /* open with RMS record locking */
	    unsigned fib$v_writethru	: 1; /* force cache write-through on operation */
	    unsigned fib$v_nolock	: 1; /* override access interlocks */
	    unsigned fib$v_norecord	: 1; /* do not record file access */
	    unsigned fib$v_noverify	: 1; /* do not perform compare on move. */
	    unsigned fib$v_change_vol	: 1; /* allow movefile move between volumes in a set. */
	    unsigned			: 8;
	} fib$r_acctl_bits0;
#define fib$v_nowrite fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_nowrite
#define fib$v_dlock fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_dlock
#define fib$v_blk_lock fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_blk_lock
#define fib$v_fastrdsqnos fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_fastrdsqnos
#define fib$v_spool fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_spool
#define fib$v_writeck fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_writeck
#define fib$v_seqonly fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_seqonly
#define fib$v_seqno fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_seqno
#define fib$v_write fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_write
#define fib$v_readck fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_readck
#define fib$v_noread fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_noread
#define fib$v_notrunc fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_notrunc
#define fib$v_control fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_control
#define fib$v_no_read_data fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_no_read_data
#define fib$v_execute fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_execute
#define fib$v_prsrv_atr fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_prsrv_atr
#define fib$v_rmslock fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_rmslock
#define fib$v_writethru fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_writethru
#define fib$v_nolock fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_nolock
#define fib$v_norecord fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_norecord
#define fib$v_noverify fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_noverify
#define fib$v_change_vol fib$r_acctl_overlay.fib$r_acctl_bits0.fib$v_change_vol
	struct {
	    unsigned char	       : 3;
	    unsigned char fib$v_rewind : 1; /* rewind tape */
	    unsigned char fib$v_curpos : 1; /* create at current tape position */
	    unsigned char 	       : 1;
	    unsigned char fib$v_update : 1; /* update mode (position to start of file) */
	    unsigned char	       : 1;
	} fib$r_acctl_bits1;
#define fib$v_rewind fib$r_acctl_overlay.fib$r_acctl_bits1.fib$v_rewind
#define fib$v_curpos fib$r_acctl_overlay.fib$r_acctl_bits1.fib$v_curpos
#define fib$v_update fib$r_acctl_overlay.fib$r_acctl_bits1.fib$v_update
	struct {
	    unsigned char	: 8, : 8, : 8;	/* char fill[3]; */
	    char fib$b_wsize;		/* window size */
	} fib$r_acctl_fields2;
#define fib$b_wsize fib$r_acctl_overlay.fib$r_acctl_fields2.fib$b_wsize
    } fib$r_acctl_overlay;
    union {
	unsigned short fib$w_fid[3];	/* file id */
#define fib$w_fid fib$r_fid_overlay.fib$w_fid
	struct {
	    unsigned short fib$w_fid_num; /* file number */
	    unsigned short fib$w_fid_seq; /* file sequence number */
#define fib$w_fid_num fib$r_fid_overlay.fib$r_fid_fields.fib$w_fid_num
#define fib$w_fid_seq fib$r_fid_overlay.fib$r_fid_fields.fib$w_fid_seq
	    union {
		unsigned short fib$w_fid_rvn; /* relative volume number */
#define fib$w_fid_rvn fib$r_fid_overlay.fib$r_fid_fields.fib$r_fid_rvn_overlay.fib$w_fid_rvn
		struct {
		    unsigned char fib$b_fid_rvn; /* short form RVN */
		    unsigned char fib$b_fid_nmx; /* extended file number */
		} fib$r_fid_rvn_fields;
#define fib$b_fid_rvn fib$r_fid_overlay.fib$r_fid_fields.fib$r_fid_rvn_overlay.fib$r_fid_rvn_fields.fib$b_fid_rvn
#define fib$b_fid_nmx fib$r_fid_overlay.fib$r_fid_fields.fib$r_fid_rvn_overlay.fib$r_fid_rvn_fields.fib$b_fid_nmx
	    } fib$r_fid_rvn_overlay;
	} fib$r_fid_fields;
	struct {				/* file ID fields for ISO 9660 */
	    unsigned short fib$w_fid_dirnum;	/* directory number of file-ID */
	    unsigned int fib$l_fid_recnum __attribute__ ((packed));	/* record number of file-ID */
	} fib$r_fid_iso_9660_fields __attribute__ ((packed));
#define fib$w_fid_dirnum fib$r_fid_overlay.fib$r_fid_iso_9660_fields.fib$w_fid_dirnum
#define fib$l_fid_recnum fib$r_fid_overlay.fib$r_fid_iso_9660_fields.fib$l_fid_recnum
    } fib$r_fid_overlay;
    union {
	unsigned short fib$w_did[3];	/* directory id */
#define fib$w_did fib$r_did_overlay.fib$w_did
	struct {
	    unsigned short fib$w_did_num; /* file number */
	    unsigned short fib$w_did_seq; /* file sequence number */
#define fib$w_did_num fib$r_did_overlay.fib$r_did_fields.fib$w_did_num
#define fib$w_did_seq fib$r_did_overlay.fib$r_did_fields.fib$w_did_seq
	    union {
		unsigned short fib$w_did_rvn; /* relative volume number */
#define fib$w_did_rvn fib$r_did_overlay.fib$r_did_fields.fib$r_did_rvn_overlay.fib$w_did_rvn
		struct {
		    unsigned char fib$b_did_rvn; /* short form RVN */
		    unsigned char fib$b_did_nmx; /* extended file number */
		} fib$r_did_rvn_fields;
#define fib$b_did_rvn fib$r_did_overlay.fib$r_did_fields.fib$r_did_rvn_overlay.fib$r_did_rvn_fields.fib$b_did_rvn
#define fib$b_did_nmx fib$r_did_overlay.fib$r_did_fields.fib$r_did_rvn_overlay.fib$r_did_rvn_fields.fib$b_did_nmx
	    } fib$r_did_rvn_overlay;
	} fib$r_did_fields __attribute__ ((packed));
	struct {				/* file ID fields for ISO 9660 */
	    unsigned short fib$w_did_dirnum;	/* directory number of dir-ID */
	    unsigned int fib$l_did_recnum __attribute__ ((packed));	/* record number of dir-ID */
	} fib$r_did_iso_9660_fields;
#define fib$w_did_dirnum fib$r_did_overlay.fib$r_did_iso_9660_fields.fib$w_did_dirnum
#define fib$l_did_recnum fib$r_did_overlay.fib$r_did_iso_9660_fields.fib$l_did_recnum
    } fib$r_did_overlay;
    unsigned long fib$l_wcc;		/* wild card context */
    union {
	unsigned short fib$w_nmctl;	/* name control bits */
#define fib$w_nmctl fib$r_nmctl_overlay.fib$w_nmctl
	struct {
	    unsigned short		  : 3;
	    unsigned short fib$v_allver   : 1; /* match all versions */
	    unsigned short fib$v_alltyp   : 1; /* match all types */
	    unsigned short fib$v_allnam   : 1; /* match all names */
	    unsigned short		  : 2;
	    unsigned short fib$v_wild     : 1; /* wild cards in file name */
	    unsigned short fib$v_newver   : 1; /* maximize version number */
	    unsigned short fib$v_supersede: 1; /* supersede existing file */
	    unsigned short fib$v_findfid  : 1; /* search for file id */
	    unsigned short		  : 2;
	    unsigned short fib$v_lowver   : 1; /* lower version of file exists */
	    unsigned short fib$v_highver  : 1; /* higher version of file exists */
	} fib$r_nmctl_bits __attribute__ ((packed));
#define fib$v_allver fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_allver
#define fib$v_alltyp fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_alltyp
#define fib$v_allnam fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_allnam
#define fib$v_wild fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_wild
#define fib$v_newver fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_newver
#define fib$v_supersede fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_supersede
#define fib$v_findfid fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_findfid
#define fib$v_lowver fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_lowver
#define fib$v_highver fib$r_nmctl_overlay.fib$r_nmctl_bits.fib$v_highver
    } fib$r_nmctl_overlay;
    union {
	unsigned short fib$w_exctl __attribute__ ((packed));	/* extend control */
#define fib$w_exctl fib$r_exctl_overlay.fib$w_exctl
	struct {
	    unsigned short fib$v_alcon    : 1; /* allocate contiguous */
	    unsigned short fib$v_alconb   : 1; /* contiguous best effort */
	    unsigned short fib$v_filcon   : 1; /* mark file contiguous */
	    unsigned short fib$v_aldef    : 1; /* allocate default amount */
	    unsigned short fib$v_allocatr : 1; /* placement data present in attribute list */
	    unsigned short 	    : 2;
	    unsigned short fib$v_extend   : 1; /* enable extension */
	    unsigned short fib$v_trunc    : 1; /* enable truncation */
	    unsigned short fib$v_nohdrext : 1; /* inhibit extension headers */
	    unsigned short fib$v_markbad  : 1; /* mark blocks bad */
	    unsigned short 	    : 3;
	    unsigned short fib$v_noplace  : 1; /* don't add placement pointers in movefile */
	    unsigned short fib$v_nocharge : 1; /* don't charge diskquota */
	} fib$r_exctl_bits;
#define fib$v_alcon fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_alcon
#define fib$v_alconb fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_alconb
#define fib$v_filcon fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_filcon
#define fib$v_aldef fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_aldef
#define fib$v_allocatr fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_allocatr
#define fib$v_extend fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_extend
#define fib$v_trunc fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_trunc
#define fib$v_nohdrext fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_nohdrext
#define fib$v_markbad fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_markbad
#define fib$v_noplace fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_noplace
#define fib$v_nocharge fib$r_exctl_overlay.fib$r_exctl_bits.fib$v_nocharge
    } fib$r_exctl_overlay;
    unsigned long fib$l_exsz;		/* extend size */
    unsigned long fib$l_exvbn;		/* extension VBN */
    union {
	unsigned char fib$b_alopts;	/* allocation options */
#define fib$b_alopts fib$r_alopts_overlay.fib$b_alopts
	struct {
	    unsigned char fib$v_exact : 1;	/* exact placement required */
	    unsigned char fib$v_oncyl : 1;	/* put allocation on one cylinder */
	    unsigned char 	      : 6;
	} fib$r_alopts_bits;
#define fib$v_exact fib$r_alopts_overlay.fib$r_alopts_bits.fib$v_exact
#define fib$v_oncyl fib$r_alopts_overlay.fib$r_alopts_bits.fib$v_oncyl
    } fib$r_alopts_overlay;
    unsigned char fib$b_alalign __attribute__ ((packed));	/* allocation alignment */
    union {
	unsigned short fib$w_alloc[5];	/* allocation location */
#define fib$w_alloc fib$r_alloc_overlay.fib$w_alloc
	struct {
	    union {
		unsigned short fib$w_loc_fid[3]; /* related file id */
#define fib$w_loc_fid fib$r_alloc_overlay.fib$r_alloc_fields.fib$r_loc_fid_overlay.fib$w_loc_fid
		struct {
		    unsigned short fib$w_loc_num; /* related file number */
		    unsigned short fib$w_loc_seq; /* file sequence number */
#define fib$w_loc_num fib$r_alloc_overlay.fib$r_alloc_fields.fib$r_loc_fid_overlay.fib$r_loc_fid_fields.fib$w_loc_num
#define fib$w_loc_seq fib$r_alloc_overlay.fib$r_alloc_fields.fib$r_loc_fid_overlay.fib$r_loc_fid_fields.fib$w_loc_seq
		    union {
			unsigned short fib$w_loc_rvn; /* related RVN */
#define fib$w_loc_rvn fib$r_alloc_overlay.fib$r_alloc_fields.fib$r_loc_fid_overlay.fib$r_loc_fid_fields.fib$r_loc_rvn_overlay.fib$w_loc_rvn
			struct {
			    unsigned char fib$b_loc_rvn; /* short form RVN */
			    unsigned char fib$b_loc_nmx; /* extended file number */
#define fib$b_loc_rvn fib$r_alloc_overlay.fib$r_alloc_fields.fib$r_loc_fid_overlay.fib$r_loc_fid_fields.fib$r_loc_rvn_overlay.fib$r_loc_rvn_fields.fib$b_loc_rvn
#define fib$b_loc_nmx fib$r_alloc_overlay.fib$r_alloc_fields.fib$r_loc_fid_overlay.fib$r_loc_fid_fields.fib$r_loc_rvn_overlay.fib$r_loc_rvn_fields.fib$b_loc_nmx
			} fib$r_loc_rvn_fields;
		    } fib$r_loc_rvn_overlay;
		} fib$r_loc_fid_fields;
	    } fib$r_loc_fid_overlay;
	    unsigned long fib$l_loc_addr __attribute__ ((packed)); /* location address (VBN, LBN, CYL) */
#define fib$l_loc_addr fib$r_alloc_overlay.fib$r_alloc_fields.fib$l_loc_addr
	} fib$r_alloc_fields;
    } fib$r_alloc_overlay __attribute__ ((packed));
    unsigned short fib$w_verlimit;	/* directory entry version limit */
    unsigned char fib$b_agent_mode;	/* agents access mode */
    unsigned char fib$b_ru_facility;	/* recoverable-facility code */
    unsigned long fib$l_aclctx;		/* ACL context for read */
    unsigned long fib$l_acl_status;	/* return status from ACL operation */
    union {
	unsigned long fib$l_status;	/* general status longword */
#define fib$l_status fib$r_status_overlay.fib$l_status
	struct {
	    unsigned fib$v_alt_req	: 1; /* alternate access required */
	    unsigned fib$v_alt_granted	: 1; /* alternate access granted */
	    unsigned fib$v_diracl	: 1; /* do directory ACL propagation */
	    unsigned fib$v_propagate	: 1; /* do propagation on enter */
	    unsigned fib$v_nocopyacl	: 1; /* don't propagate the ACL */
	    unsigned fib$v_nocopyowner	: 1; /* don't propagate the owner UIC */
	    unsigned fib$v_nocopyprot	: 1; /* don't propagate the SOGW protection */
	    unsigned fib$v_exclprevious : 1; /* exclude the previous version from propagation */
	    unsigned fib$v_alias_entry	: 1; /* file accessed via an alias directory entry */
	    unsigned fib$v_wildfid_flag : 1; /* wildcard FID flag */
	    unsigned			: 22;
#define fib$v_alt_req fib$r_status_overlay.fib$r_status_bits.fib$v_alt_req
#define fib$v_alt_granted fib$r_status_overlay.fib$r_status_bits.fib$v_alt_granted
#define fib$v_diracl fib$r_status_overlay.fib$r_status_bits.fib$v_diracl
#define fib$v_propagate fib$r_status_overlay.fib$r_status_bits.fib$v_propagate
#define fib$v_nocopyacl fib$r_status_overlay.fib$r_status_bits.fib$v_nocopyacl
#define fib$v_nocopyowner fib$r_status_overlay.fib$r_status_bits.fib$v_nocopyowner
#define fib$v_nocopyprot fib$r_status_overlay.fib$r_status_bits.fib$v_nocopyprot
#define fib$v_exclprevious fib$r_status_overlay.fib$r_status_bits.fib$v_exclprevious
#define fib$v_alias_entry fib$r_status_overlay.fib$r_status_bits.fib$v_alias_entry
#define fib$v_wildfid_flag fib$r_status_overlay.fib$r_status_bits.fib$v_wildfid_flag
	} fib$r_status_bits;
    } fib$r_status_overlay;
    unsigned long fib$l_alt_access;	/* alternate access mask */
    union {
	struct {
	    unsigned long fib$l_mov_svbn;	/* starting VBN (MOVEFILE) */
	    unsigned long fib$l_mov_vbncnt;	/* count of VBNs (MOVEFILE) */
#define fib$l_mov_svbn fib$r_funcdepend.fib$r_movfildp.fib$l_mov_svbn
#define fib$l_mov_vbncnt fib$r_funcdepend.fib$r_movfildp.fib$l_mov_vbncnt
	} fib$r_movfildp;
    } fib$r_funcdepend;
#ifndef NO_VMS_V6
    unsigned short fib$w_file_hdrseq_incr;	/* header seq no increment for indiv file */
    unsigned short fib$w_dir_hdrseq_incr;	/* header seq no increment for directory file */
    unsigned short fib$w_file_dataseq_incr;	/* data seq no increment for indiv file */
    unsigned short fib$w_dir_dataseq_incr;	/* data seq no increment for driectory file */
#endif
};

/* define acp control function codes */
#define FIB$C_REWINDVOL 1		/* rewind volume set */
#define FIB$C_POSEND	2		/* position to end of volume set */
#define FIB$C_NEXTVOL	3		/* force next volume */
#define FIB$C_SPACE	4		/* space magnetic tape */
#define FIB$C_ILLEGAL	5		/* */
#define FIB$C_REWINDFIL 6		/* rewind file */
#define FIB$C_LOCK_VOL	7		/* lock volume against allocation */
#define FIB$C_UNLK_VOL	8		/* unlock volume */
/* quota file operations */
#define FIB$C_ENA_QUOTA 9		/* enable quota file */
#define FIB$C_DSA_QUOTA 10		/* disable quota file */
#define FIB$C_ADD_QUOTA 11		/* add quota file entry */
#define FIB$C_EXA_QUOTA 12		/* examine quota file entry */
#define FIB$C_MOD_QUOTA 13		/* modify quota file entry */
#define FIB$C_REM_QUOTA 14		/* remove quota file entry */
#define FIB$C_USEREOT	15		/* enable user end of tape handling */
#define FIB$C_REMAP	16		/* remap file window */
#define FIB$C_CLSEREXCP 17		/* allow the user to clear a serious excp from a tape drive */
#define FIB$C_FLUSH_CACHE 18		/* flush selected cache */
#define FIB$C_FORCE_MV	19		/* force mount verification to occur */
#define FIB$K_MTALEN	28		/* length of MTAACP data */
#define FIB$C_MTALEN	28
/* cache identifier codes for flush_cache */
#define FIB$C_FID_CACHE    1
#define FIB$C_EXTENT_CACHE 2
#define FIB$C_QUOTA_CACHE  3
#define FIB$C_BFRD_CACHE   4
#define FIB$C_VBN_CACHE    5
/* control bits for quota file operations */
#define FIB$V_ALL_MEM	0
#define FIB$V_ALL_GRP	1
#define FIB$V_MOD_USE	2
#define FIB$V_MOD_PERM	3
#define FIB$V_MOD_OVER	4
#define FIB$M_ALL_MEM	(1<<FIB$V_ALL_MEM)	/* 0x01 */
#define FIB$M_ALL_GRP	(1<<FIB$V_ALL_GRP)	/* 0x02 */
#define FIB$M_MOD_USE	(1<<FIB$V_MOD_USE)	/* 0x04 */
#define FIB$M_MOD_PERM	(1<<FIB$V_MOD_PERM)	/* 0x08 */
#define FIB$M_MOD_OVER	(1<<FIB$V_MOD_OVER)	/* 0x10 */
struct fibdef1 {
    char fibdef1_fill[22];
    unsigned short fib$w_cntrlfunc;	/* acp control function */
    union {
	unsigned long fib$l_cntrlval;	/* acp control function value parameter */
#define fib$l_cntrlval fib$r_cntrlval_overlay.fib$l_cntrlval
	struct {
	    unsigned fib$v_all_mem  : 1; /* match all member numbers */
	    unsigned fib$v_all_grp  : 1; /* match all group numbers */
	    unsigned fib$v_mod_use  : 1; /* modify usage data */
	    unsigned fib$v_mod_perm : 1; /* modify permanent quota */
	    unsigned fib$v_mod_over : 1; /* modify overdraft limit */
	    unsigned		    : 3;
#define fib$v_all_mem fib$r_cntrlval_overlay.fib$r_cntrlval_bits.fib$v_all_mem
#define fib$v_all_grp fib$r_cntrlval_overlay.fib$r_cntrlval_bits.fib$v_all_grp
#define fib$v_mod_use fib$r_cntrlval_overlay.fib$r_cntrlval_bits.fib$v_mod_use
#define fib$v_mod_perm fib$r_cntrlval_overlay.fib$r_cntrlval_bits.fib$v_mod_perm
#define fib$v_mod_over fib$r_cntrlval_overlay.fib$r_cntrlval_bits.fib$v_mod_over
	} fib$r_cntrlval_bits;
    } fib$r_cntrlval_overlay;
};

#endif	/*_FIBDEF_H*/
