/* <gsydef.h>
 *
 *	OBJFMT -- GSD entry - symbol definition
 */
#ifndef _GSYDEF_H
#define _GSYDEF_H

/* common to definitions, references, and entry point definitions. */
#define GSY$V_WEAK	0
#define GSY$V_DEF	1
#define GSY$V_UNI	2
#define GSY$V_REL	3
#define GSY$V_COMM	4
#define GSY$M_WEAK	(1<<GSY$V_WEAK)		/* 0x01 */
#define GSY$M_DEF	(1<<GSY$V_DEF)		/* 0x02 */
#define GSY$M_UNI	(1<<GSY$V_UNI)		/* 0x04 */
#define GSY$M_REL	(1<<GSY$V_REL)		/* 0x08 */
#define GSY$M_COMM	(1<<GSY$V_COMM)		/* 0x10 */
struct gsydef {
    unsigned char gsy$b_gsdtyp;		/* type field */
    unsigned char gsy$b_datyp;		/* symbol data type */
    union {
	unsigned short gsy$w_flags;	/* symbol flags */
	struct {
	    unsigned gsy$v_weak : 1;	/* weak symbol */
	    unsigned gsy$v_def	: 1;	/* definition */
	    unsigned gsy$v_uni	: 1;	/* universal */
	    unsigned gsy$v_rel	: 1;	/* relocatable */
	    unsigned gsy$v_comm : 1;	/* C common globaldef */
	    unsigned		: 3;
	} gsy$r_flags_bits;
    } gsy$r_flags_overlay;
};

#endif	/*_GSYDEF_H*/
