/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <lib$routines.h>
 *
 *	General run-time library routines.
 */
#ifndef _LIB$ROUTINES_H
#define _LIB$ROUTINES_H
# ifdef __cplusplus
extern "C" {
# endif

/*	LIB$ADAWI		-- add aligned word with interlock */
#define lib$adawi LIB$ADAWI
unsigned long lib$adawi(const short *,short *,short *);
/*	LIB$ADD_TIMES		-- add two quadword times */
#define lib$add_times LIB$ADD_TIMES
unsigned long lib$add_times(const void *,const void *,void *);
/*	LIB$ADDX		-- add two multiple-precision binary numbers */
#define lib$addx LIB$ADDX
unsigned long lib$addx(const void *,const void *,void *,...);
/*	LIB$ANALYZE_SDESC	-- analyze string descriptors */
#define lib$analyze_sdesc LIB$ANALYZE_SDESC
unsigned long lib$analyze_sdesc(const void *,unsigned short *,void *);
/*	LIB$ASCII_TO_UID	-- convert text to UID */
#define lib$ascii_to_uid LIB$ASCII_TO_UID
unsigned long lib$ascii_to_uid();
/*	LIB$ASN_WTH_MBX		-- assign channel with mailbox */
#define lib$asn_wth_mbx LIB$ASN_WTH_MBX
unsigned long lib$asn_wth_mbx(const void *,const long *,const long *,
			      unsigned short *,unsigned short *);
/*	LIB$AST_IN_PROG		-- AST in progress */
#define lib$ast_in_prog LIB$AST_IN_PROG
int lib$ast_in_prog(void);		/*(boolean)*/
/*	LIB$ATTACH		-- attach terminal to process */
#define lib$attach LIB$ATTACH
unsigned long lib$attach(const unsigned long *);
/*	LIB$BBCCI		-- test and clear or set bit with interlock */
#define lib$bbcci LIB$BBCCI
int lib$bbcci(const int *,void *), lib$bbssi(const int *,void *);  /*(boolean)*/
/*	LIB$CALLG		-- call routine with general argument list */
#define lib$callg LIB$CALLG
unsigned long lib$callg(const void *,const unsigned long (*)()); /*(arbitrary)*/
/*	LIB$CHAR		-- transform byte to first character of string */
#define lib$char LIB$CHAR
unsigned long lib$char(void *,const char *);
/*	LIB$COMPARE_UID		-- compare two UIDs */
#define lib$compare_uid LIB$COMPARE_UID
unsigned long lib$compare_uid();
/*	LIB$CONVERT_DATE_STRING -- convert date string to quadword */
#define lib$convert_date_string LIB$CONVERT_DATE_STRING
unsigned long lib$convert_date_string(const void *,void *,...);
/*	LIB$CRC			-- calculate a cyclic redundancy check (CRC) */
#define lib$crc LIB$CRC
unsigned long lib$crc(const void *,const long *,const void *);
/*	LIB$CRC_TABLE		-- construct a cyclic redundancy check (CRC) table */
#define lib$crc_table LIB$CRC_TABLE
void lib$crc_table(const unsigned long *,void *);
/*	LIB$CREATE_DIR		-- create a directory */
#define lib$create_dir LIB$CREATE_DIR
unsigned long lib$create_dir(const void *,...);
/*	LIB$CREATE_USER_VM_ZONE -- create user-defined storage zone */
#define lib$create_user_vm_zone LIB$CREATE_USER_VM_ZONE
unsigned long lib$create_user_vm_zone(unsigned long *,...);
/*	LIB$CREATE_VM_ZONE	-- create a new zone */
#define lib$create_vm_zone LIB$CREATE_VM_ZONE
unsigned long lib$create_vm_zone(unsigned long *,...);
/*	LIB$CRF_INS_KEY		-- insert key in cross-reference table */
#define lib$crf_ins_key LIB$CRF_INS_KEY
void lib$crf_ins_key(const void *,const void *,const long *,const unsigned long *);
/*	LIB$CRF_INS_REF		-- insert reference to a key in the cross-reference table */
#define lib$crf_ins_ref LIB$CRF_INS_REF
void lib$crf_ins_ref(const void *,const long *,const void *,long *,const long *);
/*	LIB$CRF_OUTPUT		-- output cross-reference table information */
#define lib$crf_output LIB$CRF_OUTPUT
void lib$crf_output(const void *,const long *,const long *,const long *,const long *,const long *);
/*	LIB$CURRENCY		-- get system currency symbol */
#define lib$currency LIB$CURRENCY
unsigned long lib$currency(void *,...);
/*	LIB$CVT_DTB,LIB$CVT_HTB,LIB$CVT_OTB -- convert numeric text to binary */
#define lib$cvt_dtb LIB$CVT_DTB
unsigned long lib$cvt_dtb(int,const char *,long *);
#define lib$cvt_htb LIB$CVT_HTB
unsigned long lib$cvt_htb(int,const char *,long *);
#define lib$cvt_otb LIB$CVT_OTB
unsigned long lib$cvt_otb(int,const char *,long *);
/*	LIB$CVT_DX_DX		-- general data type conversion routine */
#define lib$cvt_dx_dx LIB$CVT_DX_DX
unsigned long lib$cvt_dx_dx(const void *,void *,...);
/*	LIB$CVT_FROM_INTERNAL_TIME -- convert internal time to external time */
#define lib$cvt_from_internal_time LIB$CVT_FROM_INTERNAL_TIME
unsigned long lib$cvt_from_internal_time(const unsigned long *,long *,...);
/*	LIB$CVTF_FROM_INTERNAL_TIME -- convert internal time to external time (F-floating point value) */
#define lib$cvtf_from_internal_time LIB$CVTF_FROM_INTERNAL_TIME
unsigned long lib$cvtf_from_internal_time(const unsigned long *,float *,const void *);
/*	LIB$CVT_TO_INTERNAL_TIME -- convert external time to internal time */
#define lib$cvt_to_internal_time LIB$CVT_TO_INTERNAL_TIME
unsigned long lib$cvt_to_internal_time(const unsigned long *,const long *,void *);
/*	LIB$CVTF_TO_INTERNAL_TIME -- convert external time to internal time (F-floating point value) */
#define lib$cvtf_to_internal_time LIB$CVTF_TO_INTERNAL_TIME
unsigned long lib$cvtf_to_internal_time(const unsigned long *,const float *,void *);
/*	LIB$CVT_VECTIM		-- convert seven-word vector to internal time */
#define lib$cvt_vectim LIB$CVT_VECTIM
unsigned long lib$cvt_vectim(const void *,void *);
/*	LIB$DATE_TIME		-- date and time returned as a string */
#define lib$date_time LIB$DATE_TIME
unsigned long lib$date_time(void *);
/*	LIB$DAY			-- day number returned as a longword integer */
#define lib$day LIB$DAY
unsigned long lib$day(long *,...);
/*	LIB$DAY_OF_WEEK		-- show numeric day of week */
#define lib$day_of_week LIB$DAY_OF_WEEK
unsigned long lib$day_of_week(const void *,int *);
/*	LIB$DEC_OVER		-- enable or disable decimal overflow detection */
#define lib$dec_over LIB$DEC_OVER
unsigned long lib$dec_over(const unsigned long *);
/*	LIB$DECODE_FAULT	-- decode instruction stream during fault */
#define lib$decode_fault LIB$DECODE_FAULT
unsigned long lib$decode_fault(const void *,const void *,...);
/*	LIB$DELETE_FILE		-- delete one or more files */
#define lib$delete_file LIB$DELETE_FILE
unsigned long lib$delete_file(const void *,...);
/*	LIB$DELETE_LOGICAL	-- delete logical name */
#define lib$delete_logical LIB$DELETE_LOGICAL
unsigned long lib$delete_logical(const void *,...);
/*	LIB$DELETE_SYMBOL	-- delete CLI symbol */
#define lib$delete_symbol LIB$DELETE_SYMBOL
unsigned long lib$delete_symbol(const void *,...);
/*	LIB$DELETE_VM_ZONE	-- delete virtual memory zone */
#define lib$delete_vm_zone LIB$DELETE_VM_ZONE
unsigned long lib$delete_vm_zone(const unsigned long *);
/*	LIB$DIGIT_SEP		-- get digit separator symbol */
#define lib$digit_sep LIB$DIGIT_SEP
unsigned long lib$digit_sep(void *,...);
/*	LIB$DISABLE_CTRL	-- disable CLI interception of control characters */
#define lib$disable_ctrl LIB$DISABLE_CTRL
unsigned long lib$disable_ctrl(const unsigned long *,...);
/*	LIB$DO_COMMAND		-- execute command */
#define lib$do_command LIB$DO_COMMAND
unsigned long lib$do_command(const void *);
/*	LIB$EDIV		-- extended-precision divide */
#define lib$ediv LIB$EDIV
unsigned long lib$ediv(const long *,const void *,long *,long *);
/*	LIB$EMODD,LIB$EMODF,LIB$EMODG,LIB$EMODH -- extended multiply and integerize */
#define lib$emodd LIB$EMODD
unsigned long lib$emodd(const double *,const unsigned char *,const double *,long *,double *);
#define lib$emodf LIB$EMODF
unsigned long lib$emodf(const float *,const unsigned char *,const float *,long *,float *);
#define lib$emodg LIB$EMODG
unsigned long lib$emodg(const double *,const unsigned short *,const double *,long *,double *);
#define lib$emodh LIB$EMODH
unsigned long lib$emodh(const void *,const unsigned short *,const void *,long *,void *);
/*	LIB$EMUL		-- extended-precision multiply */
#define lib$emul LIB$EMUL
unsigned long lib$emul(const long *,const long *,const long *,void *);
/*	LIB$ENABLE_CTRL		-- enable CLI interception of control characters */
#define lib$enable_ctrl LIB$ENABLE_CTRL
unsigned long lib$enable_ctrl(const unsigned long *,...);
/*	LIB$ESTABLISH		-- establish a condition handler */
#define lib$establish LIB$ESTABLISH
unsigned long (*lib$establish(const unsigned long (*)(void *,void *)))(void *,void *);
/*	LIB$EXTV		-- extract a field and sign-extend */
#define lib$extv LIB$EXTV
long lib$extv(const int *,const unsigned char *,const void *);
/*	LIB$EXTZV		-- extract a zero-extended field */
#define lib$extzv LIB$EXTZV
long lib$extzv(const int *,const unsigned char *,const void *);
/*	LIB$FFC,LIB$FFS		-- find first clear or set bit */
#define lib$ffc LIB$FFC
unsigned long lib$ffc(const int *,const int *,const void *,int *),
	      lib$ffs(const int *,const int *,const void *,int *);
/*	LIB$FID_TO_NAME		-- convert device and file ID to file specification */
#define lib$fid_to_name LIB$FID_TO_NAME
unsigned long lib$fid_to_name(const void *,const void *,void *,...);
/*	LIB$FILE_SCAN		-- file scan */
struct FAB;	/* avoid warning, in case neither <fab.h> nor <rms.h> present */
#define lib$file_scan LIB$FILE_SCAN
unsigned long lib$file_scan(const struct FAB *,const unsigned long (*)(struct FAB *),
			    const unsigned long (*)(struct FAB *),...);
/*	LIB$FILE_SCAN_END	-- end-of-file scan */
#define lib$file_scan_end LIB$FILE_SCAN_END
unsigned long lib$file_scan_end();
/*	LIB$FIND_FILE		-- find file */
#define lib$find_file LIB$FIND_FILE
unsigned long lib$find_file(const void *,void *,unsigned long *,...);
/*	LIB$FIND_FILE_END	-- end of find file */
#define lib$find_file_end LIB$FIND_FILE_END
unsigned long lib$find_file_end(const unsigned long *);
/*	LIB$FIND_IMAGE_SYMBOL	-- find universal symbol in shareable image file */
#define lib$find_image_symbol LIB$FIND_IMAGE_SYMBOL
unsigned long lib$find_image_symbol(const void *,const void *,void *,...);
/*	LIB$FIND_VM_ZONE	-- return the next valid zone identifier */
#define lib$find_vm_zone LIB$FIND_VM_ZONE
unsigned long lib$find_vm_zone(unsigned long *,unsigned long *);
/*	LIB$FIXUP_FLT		-- fix floating reserved operand */
#define lib$fixup_flt LIB$FIXUP_FLT
unsigned long lib$fixup_flt(const void *,const void *,...);
/*	LIB$FLT_UNDER		-- floating-point underflow detection */
#define lib$flt_under LIB$FLT_UNDER
unsigned long lib$flt_under(const unsigned long *);
/*	LIB$FORMAT_DATE_TIME	-- format date and/or time */
#define lib$format_date_time LIB$FORMAT_DATE_TIME
unsigned long lib$format_date_time(void *,...);
/*	LIB$FREE_DATE_TIME_CONTEXT -- free context area used when formatting dates and times for input or output */
#define lib$free_date_time_context LIB$FREE_DATE_TIME_CONTEXT
unsigned long lib$free_date_time_context();
/*	LIB$FREE_EF		-- free event flag */
#define lib$free_ef LIB$FREE_EF
unsigned long lib$free_ef(const unsigned long *);
/*	LIB$FREE_LUN		-- free logical unit number */
#define lib$free_lun LIB$FREE_LUN
unsigned long lib$free_lun(const long *);
/*	LIB$FREE_TIMER		-- free timer storage */
#define lib$free_timer LIB$FREE_TIMER
unsigned long lib$free_timer(void *);
/*	LIB$FREE_VM		-- free virtual memory from program region */
#define lib$free_vm LIB$FREE_VM
unsigned long lib$free_vm(const long *,const void *,...);
/*	LIB$FREE_VM_PAGE	-- free virtual memory page */
#define lib$free_vm_page LIB$FREE_VM_PAGE
unsigned long lib$free_vm_page(const long *,const void *);
/*	LIB$GET_COMMAND		-- get line from SYS$COMMAND */
#define lib$get_command LIB$GET_COMMAND
unsigned long lib$get_command(void *,...);
/*	LIB$GET_COMMON		-- get string from common */
#define lib$get_common LIB$GET_COMMON
unsigned long lib$get_common(void *,...);
/*	LIB$GET_DATE_FORMAT	-- get the user's date input format */
#define lib$get_date_format LIB$GET_DATE_FORMAT
unsigned long lib$get_date_format(void *,...);
/*	LIB$GET_EF		-- get event flag */
#define lib$get_ef LIB$GET_EF
unsigned long lib$get_ef(unsigned long *);
/*	LIB$GET_FOREIGN		-- get foreign command line */
#define lib$get_foreign LIB$GET_FOREIGN
unsigned long lib$get_foreign(void *,...);
/*	LIB$GET_INPUT		-- get line from SYS$INPUT */
#define lib$get_input LIB$GET_INPUT
unsigned long lib$get_input(void *,...);
/*	LIB$GET_LUN		-- get logical unit number */
#define lib$get_lun LIB$GET_LUN
unsigned long lib$get_lun(long *);
/*	LIB$GET_MAXIMUM_DATE_LENGTH -- retrieve the maximum length of a date/time string */
#define lib$get_maximum_date_length LIB$GET_MAXIMUM_DATE_LENGTH
unsigned long lib$get_maximum_date_length(long *,...);
/*	LIB$GET_SYMBOL		-- get value of CLI symbol */
#define lib$get_symbol LIB$GET_SYMBOL
unsigned long lib$get_symbol(const void *,void *,...);
/*	LIB$GET_USERS_LANGUAGE	-- return the user's language */
#define lib$get_users_language LIB$GET_USERS_LANGUAGE
unsigned long lib$get_users_language(void *);
/*	LIB$GET_VM		-- allocate virtual memory */
#define lib$get_vm LIB$GET_VM
unsigned long lib$get_vm(const long *,void *,...);
/*	LIB$GET_VM_PAGE		-- get virtual memory page */
#define lib$get_vm_page LIB$GET_VM_PAGE
unsigned long lib$get_vm_page(const long *,void *);
/*	LIB$GETDVI		-- get device/volume information */
#define lib$getdvi LIB$GETDVI
unsigned long lib$getdvi(const long *,const unsigned short *,const void *,long *,...);
/*	LIB$GETJPI		-- get job/process information */
#define lib$getjpi LIB$GETJPI
unsigned long lib$getjpi(const long *,const unsigned long *,const void *,long *,...);
/*	LIB$GETQUI		-- get queue information */
#define lib$getqui LIB$GETQUI
unsigned long lib$getqui(const long *,const long *,const long *,const void *,
			 const unsigned long *,long *,...);
/*	LIB$GETSYI		-- get systemwide information */
#define lib$getsyi LIB$GETSYI
unsigned long lib$getsyi(const long *,void *,...);
/*	LIB$ICHAR		-- convert first character of string to integer */
#define lib$ichar LIB$ICHAR
int lib$ichar(const void *);
/*	LIB$INDEX		-- index to relative position of substring */
#define lib$index LIB$INDEX
int lib$index(const void *,const void *);
/*	LIB$INIT_DATE_TIME_CONTEXT -- initialize context area used in formatting dates and times for input or output */
#define lib$init_date_time_context LIB$INIT_DATE_TIME_CONTEXT
unsigned long lib$init_date_time_context(unsigned long *,const long *,const void *);
/*	LIB$INIT_TIMER		-- initialize times and counts */
#define lib$init_timer LIB$INIT_TIMER
unsigned long lib$init_timer();
/*	LIB$INSERT_TREE		-- insert entry in a balanced binary tree */
#define lib$insert_tree LIB$INSERT_TREE
long int lib$insert_tree(void *,void *,const unsigned long *,
			 const int (*)(void *,void *,void *),
			 const void (*)(void *,void *,void *),...);
/*	LIB$INSQHI		-- insert entry at head of queue */
#define lib$insqhi LIB$INSQHI
unsigned long lib$insqhi(void *,void *,...);
/*	LIB$INSQTI		-- insert entry at tail of queue */
#define lib$insqti LIB$INSQTI
unsigned long lib$insqti(void *,void *,...);
/*	LIB$INSV		-- insert a variable bit field */
#define lib$insv LIB$INSV
void lib$insv(const int *,const int *,const unsigned char *,void *);
/*	LIB$INT_OVER		-- integer overflow detection */
#define lib$int_over LIB$INT_OVER
unsigned long lib$int_over(const unsigned long *);
/*	LIB$LEN			-- length of string returned as longword value */
#define lib$len LIB$LEN
unsigned short lib$len(const void *);
/*	LIB$LOCC		-- locate a character */
#define lib$locc LIB$LOCC
int lib$locc(const void *,const void *);
/*	LIB$LOOKUP_KEY		-- look up keyword in table */
#define lib$lookup_key LIB$LOOKUP_KEY
unsigned long lib$lookup_key(const void *,const void *,void *,...);
/*	LIB$LOOKUP_TREE		-- look up an entry in a balanced binary tree */
#define lib$lookup_tree LIB$LOOKUP_TREE
unsigned long lib$lookup_tree(const void *,void *,const int (*)(void *,void *),void *);
/*	LIB$LP_LINES		-- lines on each printer page */
#define lib$lp_lines LIB$LP_LINES
long lib$lp_lines(void);
/*	LIB$MATCHC		-- match characters, return relative position */
#define lib$matchc LIB$MATCHC
int lib$matchc(const void *,const void *);
/*	LIB$MATCH_COND		-- match condition values */
#define lib$match_cond LIB$MATCH_COND
int lib$match_cond(const unsigned long *,const unsigned long *,...);
/*	LIB$MOVC3		-- move characters */
#define lib$movc3 LIB$MOVC3
void lib$movc3(const unsigned short *,const void *,void *);
/*	LIB$MOVC5		-- move characters with fill */
#define lib$movc5 LIB$MOVC5
void lib$movc5(const unsigned short *,const void *,const char *,
	       const unsigned short *,void *);
/*	LIB$MOVTC		-- move translated characters */
#define lib$movtc LIB$MOVTC
unsigned long lib$movtc(const void *,const void *,const void *,void *);
/*	LIB$MOVTUC		-- move translated until character */
#define lib$movtuc LIB$MOVTUC
int lib$movtuc(const void *,const void *,const void *,void *,...);
/*	LIB$MULT_DELTA_TIME	-- multiply delta time by scalar */
#define lib$mult_delta_time LIB$MULT_DELTA_TIME
unsigned long lib$mult_delta_time(const long *,void *);
/*	LIB$MULTF_DELTA_TIME	-- multiply delta time by an F_floating scalar */
#define lib$multf_delta_time LIB$MULTF_DELTA_TIME
unsigned long lib$multf_delta_time(const float *,void *);
/*	LIB$PAUSE		-- pause program execution */
#define lib$pause LIB$PAUSE
unsigned long lib$pause(void);
/*	LIB$POLYD,LIB$POLYF,LIB$POLYG,LIB$POLYH -- evaluate polynomials */
#define lib$polyd LIB$POLYD
unsigned long lib$polyd(const double *,const short *,const double *,double *);
#define lib$polyf LIB$POLYF
unsigned long lib$polyf(const float *,const short *,const float *,float *);
#define lib$polyg LIB$POLYG
unsigned long lib$polyg(const double *,const short *,const double *,double *);
#define lib$polyh LIB$POLYH
unsigned long lib$polyh(const void *,const short *,const void *,void *);
/*	LIB$PUT_COMMON		-- put string to common */
#define lib$put_common LIB$PUT_COMMON
unsigned long lib$put_common(const void *,...);
/*	LIB$PUT_OUTPUT		-- put line to SYS$OUTPUT */
#define lib$put_output LIB$PUT_OUTPUT
unsigned long lib$put_output(const void *);
/*	LIB$RADIX_POINT		-- radix point symbol */
#define lib$radix_point LIB$RADIX_POINT
unsigned long lib$radix_point(void *,...);
/*	LIB$REMQHI		-- remove entry from head of queue */
#define lib$remqhi LIB$REMQHI
unsigned long lib$remqhi(void *,void *,...);
/*	LIB$REMQTI		-- remove entry from tail of queue */
#define lib$remqti LIB$REMQTI
unsigned long lib$remqti(void *,void *,...);
/*	LIB$RENAME_FILE		-- rename one or more files */
#define lib$rename_file LIB$RENAME_FILE
unsigned long lib$rename_file(const void *,const void *,...);
/*	LIB$RESERVE_EF		-- reserve event flag */
#define lib$reserve_ef LIB$RESERVE_EF
unsigned long lib$reserve_ef(const unsigned long *);
/*	LIB$RESET_VM_ZONE	-- reset virtual memory zone */
#define lib$reset_vm_zone LIB$RESET_VM_ZONE
unsigned long lib$reset_vm_zone(const unsigned long *);
/*	LIB$REVERT		-- revert to the handler of the routine activator */
#define lib$revert LIB$REVERT
unsigned long (*lib$revert(void))(void *,void *);
/*	LIB$RUN_PROGRAM		-- run new program */
#define lib$run_program LIB$RUN_PROGRAM
unsigned long lib$run_program(const void *);
/*	LIB$SCANC		-- scan for characters, return relative position */
#define lib$scanc LIB$SCANC
int lib$scanc(const void *,const unsigned char *,const unsigned char *);
/*	LIB$SCOPY_DXDX		-- copy source string passed by descriptor to destination */
#define lib$scopy_dxdx LIB$SCOPY_DXDX
unsigned long lib$scopy_dxdx(const void *,void *);
/*	LIB$SCOPY_R_DX		-- copy source string passed by reference to destination string */
#define lib$scopy_r_dx LIB$SCOPY_R_DX
unsigned long lib$scopy_r_dx(const unsigned short *,const void *,void *);
/*	LIB$SET_LOGICAL		-- set logical name */
#define lib$set_logical LIB$SET_LOGICAL
unsigned long lib$set_logical(const void *,const void *,...);
/*	LIB$SET_SYMBOL		-- set value of CLI symbol */
#define lib$set_symbol LIB$SET_SYMBOL
unsigned long lib$set_symbol(const void *,const void *,...);
/*	LIB$SFREE1_DD		-- free one dynamic string */
#define lib$sfree1_dd LIB$SFREE1_DD
unsigned long lib$sfree1_dd(void *);
/*	LIB$SFREEN_DD		-- free one or more dynamic strings */
#define lib$sfreen_dd LIB$SFREEN_DD
unsigned long lib$sfreen_dd(const unsigned *,void *);
/*	LIB$SGET1_DD		-- get one dynamic string */
#define lib$sget1_dd LIB$SGET1_DD
unsigned long lib$sget1_dd(const unsigned short *,void *);
/*	LIB$SHOW_TIMER		-- show accumulated times and counts */
#define lib$show_timer LIB$SHOW_TIMER
unsigned long lib$show_timer();
/*	LIB$SHOW_VM		-- show virtual memory statistics */
#define lib$show_vm LIB$SHOW_VM
unsigned long lib$show_vm();
/*	LIB$SHOW_VM_ZONE	-- return information about a zone */
#define lib$show_vm_zone LIB$SHOW_VM_ZONE
unsigned long lib$show_vm_zone(const unsigned long *,...);
/*	LIB$SIGNAL		-- signal exception condition */
#define lib$signal LIB$SIGNAL
void lib$signal(unsigned long,...) __asm ("LIB$SIGNAL");
/*	LIB$SIG_TO_RET		-- signal converted to a return status */
#define lib$sig_to_ret LIB$SIG_TO_RET
unsigned long lib$sig_to_ret(void *,void *);
/*	LIB$SIG_TO_STOP		-- convert a signaled condition to a signaled stop */
#define lib$sig_to_stop LIB$SIG_TO_STOP
unsigned long lib$sig_to_stop(void *,void *);
/*	LIB$SIM_TRAP		-- simulate floating trap */
#define lib$sim_trap LIB$SIM_TRAP
unsigned long lib$sim_trap(void *,void *);
/*	LIB$SKPC		-- skip equal characters */
#define lib$skpc LIB$SKPC
int lib$skpc(const void *,const void *);
/*	LIB$SPANC		-- skip selected characters */
#define lib$spanc LIB$SPANC
int lib$spanc(const void *,const unsigned char *,const unsigned char *);
/*	LIB$SPAWN		-- spawn subprocess */
#define lib$spawn LIB$SPAWN
unsigned long lib$spawn();
/*	LIB$STAT_TIMER		-- statistics, return accumulated times and counts */
#define lib$stat_timer LIB$STAT_TIMER
unsigned long lib$stat_timer(const int *,void *,...);
/*	LIB$STAT_VM		-- return virtual memory statistics */
#define lib$stat_vm LIB$STAT_VM
unsigned long lib$stat_vm(const int *,void *);
/*	LIB$STAT_VM_ZONE	-- return information about a zone */
#define lib$stat_vm_zone LIB$STAT_VM_ZONE
unsigned long lib$stat_vm_zone(const unsigned long *,const int *,void *);
/*	LIB$STOP		-- stop execution and signal the condition */
#define lib$stop LIB$STOP
void lib$stop(unsigned long,...);
/*	LIB$SUB_TIMES		-- subtract two quadword times */
#define lib$sub_times LIB$SUB_TIMES
unsigned long lib$sub_times(const void *,const void *,void *);
/*	LIB$SUBX		-- multiple-precision binary subtraction */
#define lib$subx LIB$SUBX
unsigned long lib$subx(const void *,const void *,void *,...);
/*	LIB$SYS_ASCTIM		-- invoke $ASCTIM to convert binary time to ASCII string */
#define lib$sys_asctim LIB$SYS_ASCTIM
unsigned long lib$sys_asctim(unsigned short *,void *,...);
/*	LIB$SYS_FAO		-- invoke $FAO system service to format output */
#define lib$sys_fao LIB$SYS_FAO
unsigned long lib$sys_fao(const void *,unsigned short *,void *,...);
/*	LIB$SYS_FAOL		-- invoke $FAOL system service to format output */
#define lib$sys_faol LIB$SYS_FAOL
unsigned long lib$sys_faol(const void *,unsigned short *,void *,const void *);
/*	LIB$SYS_GETMSG		-- invoke $GETMSG system service to get message text */
#define lib$sys_getmsg LIB$SYS_GETMSG
unsigned long lib$sys_getmsg(const unsigned long *,unsigned short *,void *,...);
/*	LIB$SYS_TRNLOG		-- invoke $TRNLOG system service to translate logical name */
#define lib$sys_trnlog LIB$SYS_TRNLOG
unsigned long lib$sys_trnlog(const void *,unsigned short *,void *,...);
/*	LIB$TPARSE		-- table-driven finite-state parser */
#define lib$tparse LIB$TPARSE
unsigned long lib$tparse(void *,const void *,const void *);
/*	LIB$TRA_ASC_EBC		-- translate ASCII to EBCDIC */
#define lib$tra_asc_ebc LIB$TRA_ASC_EBC
unsigned long lib$tra_asc_ebc(const void *,void *);
/*	LIB$TRA_EBC_ASC		-- translate EBCDIC to ASCII */
#define lib$tra_ebc_asc LIB$TRA_EBC_ASC
unsigned long lib$tra_ebc_asc(const void *,void *);
/*	LIB$TRAVERSE_TREE	-- traverse a balanced binary tree */
#define lib$traverse_tree LIB$TRAVERSE_TREE
unsigned long lib$traverse_tree(const void *,const unsigned long (*)(void *,void *),...);
/*	LIB$TRIM_FILESPEC	-- fit long file specification into fixed field */
#define lib$trim_filespec LIB$TRIM_FILESPEC
unsigned long lib$trim_filespec(const void *,void *);
/*	LIB$UID_TO_ASCII	-- convert a UID to text */
#define lib$uid_to_ascii LIB$UID_TO_ASCII
unsigned long lib$uid_to_ascii();
/*	LIB$VERIFY_VM_ZONE	-- verify a zone */
#define lib$verify_vm_zone LIB$VERIFY_VM_ZONE
unsigned long lib$verify_vm_zone(const unsigned long *);
/*	LIB$WAIT		-- wait a specified period of time */
#define lib$wait LIB$WAIT
unsigned long lib$wait(float);

# ifdef __cplusplus
}
# endif
#endif	/*_LIB$ROUTINES_H*/
