/* <lsydef.h>
 *
 *	OBJFMT -- LSY - module-Local symbol definition
 */
#ifndef _LSYDEF_H
#define _LSYDEF_H

/* common to definitions, references, entry points, and procedure definitions */
#define LSY$V_WEAK	0
#define LSY$V_DEF	1
#define LSY$V_UNI	2
#define LSY$V_REL	3
#define LSY$M_WEAK	(1<<LSY$V_WEAK)		/* 0x01 */
#define LSY$M_DEF	(1<<LSY$V_DEF)		/* 0x02 */
#define LSY$M_UNI	(1<<LSY$V_UNI)		/* 0x04 */
#define LSY$M_REL	(1<<LSY$V_REL)		/* 0x08 */
struct lsydef {
    unsigned char lsy$b_gsdtyp;		/* type field */
    unsigned char lsy$b_datyp;		/* symbol type */
    union {
	unsigned short lsy$w_flags;	/* symbol flags */
	struct {
	    unsigned lsy$v_weak : 1;	/* weak symbol (not used) */
	    unsigned lsy$v_def	: 1;	/* defined symbol */
	    unsigned lsy$v_uni	: 1;	/* universal (not used) */
	    unsigned lsy$v_rel	: 1;	/* relocatable */
	    unsigned		: 4;
	} lsy$r_flags_bits;
    } lsy$r_flags_overlay;
    unsigned short lsy$w_envindx;	/* environment index */
};

#endif	/*_LSYDEF_H*/
