/* <vms/lib/moddef.h>
 *
 *	LIB - RMS modify definitions (equivalent to <vms/rmedef.h>
 */
#ifndef _MODDEF_H
#define _MODDEF_H

/*
   The following values identify various requests for non-standard rms
   functions.  They are currently input to the $modify function in the
   ctx field of the fab only if the esc bit is set in fop (rab functions
   are also accepted).	Incorrect use of these capabilties could cause
   RMS to fail, hence great caution should be exercised in their use.

   The first five functions are also called RME$C_xxxx.  They are defined
   in the public module RMSUSR.SDL and cannot be changed.
 */

/* FAB function calls */
#define MOD$C_SETRFM		1	/* change rfm, mrs, and fsz (if vfc) in ifab only */
#define MOD$C_PPFECHO		2	/* enable echo of SYS$INPUT to SYS$OUTPUT */
#define MOD$C_SETRCF		3	/* change recovery mode */
#define MOD$C_KEEP_LOCK_ON	4	/* turn on Keep Lock behavior */
#define MOD$C_KEEP_LOCK_OFF	5	/* turn off Keep Lock behavior */
#define MOD$C_RU_ACE_ON		6	/* turn on RU ACE locking */
#define MOD$C_RU_ACE_OFF	7	/* turn off RU ACE locking */

/* RAB function calls */
#define MOD$C_LOCK_RECORD	1	/* lock a record */
#define MOD$C_ASSOCIATE		2	/* associate a stream with a transaction */

#endif	/*_MODDEF_H*/
