/* <objrecdef.h>
 *
 *	OBJFMT -- object record definitions
 */
#ifndef _OBJRECDEF_H
#define _OBJRECDEF_H
#define OBJ$V_PSC_PIC	0
#define OBJ$V_PSC_LIB	1
#define OBJ$V_PSC_OVL	2
#define OBJ$V_PSC_REL	3
#define OBJ$V_PSC_GBL	4
#define OBJ$V_PSC_SHR	5
#define OBJ$V_PSC_EXE	6
#define OBJ$V_PSC_RD	7
#define OBJ$V_PSC_WRT	8
#define OBJ$M_PSC_PIC	(1<<OBJ$V_PSC_PIC)	/* 0x01 */
#define OBJ$M_PSC_LIB	(1<<OBJ$V_PSC_LIB)	/* 0x02 */
#define OBJ$M_PSC_OVL	(1<<OBJ$V_PSC_OVL)	/* 0x04 */
#define OBJ$M_PSC_REL	(1<<OBJ$V_PSC_REL)	/* 0x08 */
#define OBJ$M_PSC_GBL	(1<<OBJ$V_PSC_GBL)	/* 0x10 */
#define OBJ$M_PSC_SHR	(1<<OBJ$V_PSC_SHR)	/* 0x20 */
#define OBJ$M_PSC_EXE	(1<<OBJ$V_PSC_EXE)	/* 0x40 */
#define OBJ$M_PSC_RD	(1<<OBJ$V_PSC_RD)	/* 0x80 */
#define OBJ$M_PSC_WRT	(1<<OBJ$V_PSC_WRT)	/* 0x0100 */
#define OBJ$V_SYM_WEAK	0
#define OBJ$V_SYM_DEF	1
#define OBJ$V_SYM_UNI	2
#define OBJ$V_SYM_REL	3
#define OBJ$M_SYM_WEAK	(1<<OBJ$V_SYM_WEAK)	/* 0x01 */
#define OBJ$M_SYM_DEF	(1<<OBJ$V_SYM_DEF)	/* 0x02 */
#define OBJ$M_SYM_UNI	(1<<OBJ$V_SYM_UNI)	/* 0x04 */
#define OBJ$M_SYM_REL	(1<<OBJ$V_SYM_REL)	/* 0x08 */
#define OBJ$V_SYMV_WEAK 0
#define OBJ$V_SYMV_DEF	1
#define OBJ$V_SYMV_UNI	2
#define OBJ$V_SYMV_REL	3
#define OBJ$M_SYMV_WEAK (1<<OBJ$V_SYMV_WEAK)	/* 0x01 */
#define OBJ$M_SYMV_DEF	(1<<OBJ$V_SYMV_DEF)	/* 0x02 */
#define OBJ$M_SYMV_UNI	(1<<OBJ$V_SYMV_UNI)	/* 0x04 */
#define OBJ$M_SYMV_REL	(1<<OBJ$V_SYMV_REL)	/* 0x08 */
#define OBJ$V_SYMM_WEAK 0
#define OBJ$V_SYMM_DEF	1
#define OBJ$V_SYMM_UNI	2
#define OBJ$V_SYMM_REL	3
#define OBJ$M_SYMM_WEAK (1<<OBJ$V_SYMM_WEAK)	/* 0x01 */
#define OBJ$M_SYMM_DEF	(1<<OBJ$V_SYMM_DEF)	/* 0x02 */
#define OBJ$M_SYMM_UNI	(1<<OBJ$V_SYMM_UNI)	/* 0x04 */
#define OBJ$M_SYMM_REL	(1<<OBJ$V_SYMM_REL)	/* 0x08 */

struct sdadefs {
    union {
	unsigned char obj$b_type;	/* type of record */
	unsigned char obj$b_gsd_type;	/* type of GSD record */
    } obj$r_type_overlay;
    union {
	struct {
	    unsigned char obj$b_psc_ali;	/* PSECT alignment (2**n) */
	    union {
		unsigned short obj$w_psc_flag;	/* PSECT flags: */
		struct {
		    unsigned obj$v_psc_pic : 1; /* position independent */
		    unsigned obj$v_psc_lib : 1; /* defined from sharable image */
		    unsigned obj$v_psc_ovl : 1; /* overlaid psect */
		    unsigned obj$v_psc_rel : 1; /* requires relocation */
		    unsigned obj$v_psc_gbl : 1; /* PSECT is global */
		    unsigned obj$v_psc_shr : 1; /* potentially sharable */
		    unsigned obj$v_psc_exe : 1; /* executable */
		    unsigned obj$v_psc_rd  : 1; /* can be read */
		    unsigned obj$v_psc_wrt : 1; /* can be written */
		    unsigned		   : 7;
		} obj$r_psc_flag_bits;
	    } obj$r_psc_flag_overlay;
	    unsigned long obj$l_psc_len;	/* length of PSECT */
	    char obj$t_psc_name;		/* PSECT name (counted string) */
	} obj$r_psect_record;
	struct {
	    unsigned char obj$b_sym_dtype;	/* data type (see Arch. Handbook, Ap. C) */
	    union {
		unsigned short obj$w_sym_flags; /* symbol flags: */
		struct {
		    unsigned obj$v_sym_weak: 1; /* weak resolution (0 = strong) */
		    unsigned obj$v_sym_def : 1; /* definition (0 = reference) */
		    unsigned obj$v_sym_uni : 1; /* universal definition (0 = local) */
		    unsigned obj$v_sym_rel : 1; /* relative symbol (0 = absolute) */
		    unsigned		   : 4;
		} obj$r_sym_flags_bits;
	    } obj$r_sym_flags_overlay;
	    unsigned char obj$b_sym_psind;	/* PSECT index (only if def) */
	    unsigned long obj$l_sym_value;	/* value of symbol (only if def) */
	    char obj$t_sym_name;		/* symbol name (counted string) */
	} obj$r_global_sym_record;
	struct {
	    unsigned char obj$b_epm_dtype;	/* data type (see Arch. Handbook, Ap. C) */
	    unsigned short obj$w_epm_flags;	/* flags (same as SYM_FLAGS) */
	    unsigned char obj$b_epm_psind;	/* PSECT index (only if def) */
	    unsigned long obj$l_epm_value;	/* value of symbol (only if def) */
	    unsigned short obj$w_epm_mask;	/* entry mask */
	    char obj$t_epm_name;		/* symbol name (counted string) */
	} obj$r_entry_point_record;
	struct {
	    unsigned char obj$b_symv_dtype;	/* data type (see Arch. Handbook, Ap. C) */
	    union {
		unsigned short obj$w_symv_flags; /* symbol flags: */
		struct {
		    unsigned obj$v_symv_weak: 1; /* weak resolution (0 = strong) */
		    unsigned obj$v_symv_def : 1; /* definition (0 = reference) */
		    unsigned obj$v_symv_uni : 1; /* universal definition (0 = local) */
		    unsigned obj$v_symv_rel : 1; /* relative symbol (0 = absolute) */
		    unsigned		    : 4;
		} obj$r_symv_flags_bits;
	    } obj$r_symv_flags_overlay;
	    unsigned char obj$b_symv_psind;	/* PSECT index (only if def) */
	    unsigned long obj$l_symv_value;	/* value of symbol (only if def) */
	    unsigned long obj$l_symv_vector;	/* vectored value of symbol (only if def) */
	    char obj$t_symv_name;		/* symbol name (counted string) */
	} obj$r_global_symv_record;
	struct {
	    unsigned char obj$b_epmv_dtype;	/* data type (see Arch. Handbook, Ap. C) */
	    unsigned short obj$w_epmv_flags;	/* flags (same as SYM_FLAGS) */
	    unsigned char obj$b_epmv_psind;	/* PSECT index (only if def) */
	    unsigned long obj$l_epmv_value;	/* value of symbol (only if def) */
	    unsigned long obj$l_epmv_vector;	/* vectored value of symbol (only if def) */
	    unsigned short obj$w_epmv_mask;	/* entry mask */
	    char obj$t_epmv_name;		/* symbol name (counted string) */
	} obj$r_global_epmv_record;
	struct {
	    unsigned char obj$b_symm_dtype;	/* data type (see Arch. Handbook, Ap. C) */
	    union {
		unsigned short obj$w_symm_flags; /* symbol flags: */
		struct {
		    unsigned obj$v_symm_weak: 1; /* weak resolution (0 = strong) */
		    unsigned obj$v_symm_def : 1; /* definition (0 = reference) */
		    unsigned obj$v_symm_uni : 1; /* universal definition (0 = local) */
		    unsigned obj$v_symm_rel : 1; /* relative symbol (0 = absolute) */
		    unsigned		    : 4;
		} obj$r_symm_flags_bits;
	    } obj$r_symm_flags_overlay;
	    unsigned char obj$b_symm_psind;	/* PSECT index (only if def) */
	    unsigned long obj$l_symm_value;	/* value of symbol (only if def) */
	    unsigned long obj$l_symm_version_mask; /* version mask of symbol (only if def) */
	    char obj$t_symm_name;		/* symbol name (counted string) */
	} obj$r_global_symm_record;
	struct {
	    unsigned char obj$b_epmm_dtype;	/* data type (see Arch. Handbook, Ap. C) */
	    unsigned short obj$w_epmm_flags;	/* flags (same as SYM_FLAGS) */
	    unsigned char obj$b_epmm_psind;	/* PSECT index (only if def) */
	    unsigned long obj$l_epmm_value;	/* value of symbol (only if def) */
	    unsigned long obj$l_epmm_version_mask; /* version mask of symbol (only if def) */
	    unsigned short obj$w_epmm_mask;	/* entry mask */
	    char obj$t_epmm_name;		/* symbol name (counted string) */
	} obj$r_global_epmm_record;
	struct {
	    unsigned char obj$b_eom_sev;	/* error severity for module */
	    unsigned char obj$b_eom_psind;	/* PSECT index of transfer address */
	    unsigned long obj$l_eom_trans;	/* transfer address */
	} obj$r_eom_record;
    } obj$r_records_overlay;
};

/* permissable record types */
#define OBJ$C_HDR	0	/* module header record */
#define OBJ$C_HDR_MHD	0	/*  main header record */
#define OBJ$C_HDR_LNM	1	/*  language processor record */
#define OBJ$C_HDR_SRC	2	/*  source files description */
#define OBJ$C_HDR_TTL	3	/*  title text */
#define OBJ$C_HDR_CPR	4	/*  copyright text */
#define OBJ$C_HDR_MTC	5	/*  maintenance text */
#define OBJ$C_HDR_GTX	6	/*  general text */
#define OBJ$C_GSD	1	/* global symbol definition record */
#define OBJ$C_GSD_PSC	0	/*  P-sect definition */
#define OBJ$C_GSD_SYM	1	/*  symbol (simple) definition */
#define OBJ$C_GSD_EPM	2	/*  entry point definition */
#define OBJ$C_GSD_PRO	3	/*  procedure definition */
#define OBJ$C_GSD_SYMW	4	/*  symbol definition with word psect */
#define OBJ$C_GSD_EPMW	5	/*  entry point definition with word psect */
#define OBJ$C_GSD_PROW	6	/*  procedure definition with word psect */
#define OBJ$C_GSD_IDC	7	/*  random entity check */
#define OBJ$C_GSD_ENV	8	/*  environment definition */
#define OBJ$C_GSD_LSY	9	/*  local symbol definition/reference */
#define OBJ$C_GSD_LEPM	10	/*  local symbol entry point def. */
#define OBJ$C_GSD_LPRO	11	/*  local symbol procedure def. */
#define OBJ$C_GSD_SPSC	12	/*  shareable image psect definition */
#define OBJ$C_GSD_SYMV	13	/*  global symbol definition (vectored) */
#define OBJ$C_GSD_EPMV	14	/*  entry point definition (vectored) */
#define OBJ$C_GSD_PROV	15	/*  procedure definition (vectored) */
#define OBJ$C_GSD_SYMM	16	/*  global symbol definition (special double valued) */
#define OBJ$C_GSD_EPMM	17	/*  entry point definition (special double valued) */
#define OBJ$C_GSD_PROM	18	/*  procedure definition (special double valued) */
#define OBJ$C_TIR	2	/* text information record */
#define OBJ$C_EOM	3	/* end of module record */
#define OBJ$C_DBG	4	/* debugger information record */
#define OBJ$C_TBT	5	/* traceback information record */
#define OBJ$C_LNK	6	/* linker options record */
#define OBJ$C_EOMW	7	/* end of module record with word psect */
#define OBJ$C_MAXRECTYP 7	/* last assigned record type */
/* misc. constants */
#define OBJ$K_SUBTYP	1
#define OBJ$C_SUBTYP	1
#define OBJ$C_MAXRECSIZ 2048	/* maximum legal record size */
#define OBJ$C_STRLVL	0	/* structure level */
#define OBJ$C_SYMSIZ	31	/* maximum symbol length */
#define OBJ$C_STOREPLIM (-1)	/* maximum repeat count on store commands */
#define OBJ$C_PSCALILIM 9	/* maximum p-sect alignment */

struct objrecdef {
    unsigned char obj$b_rectyp;		/* first byte always record type */
    unsigned char obj$b_subtyp;		/* record sub-type byte */
    unsigned char obj$b_mhd_strlv;	/* structure level */
    union {
	unsigned short obj$w_mhd_recsz; /* maximum record size */
	struct {
	    unsigned	: 8, : 8;	/* char fill[2]; */
	    char obj$t_mhd_name[1];	/* module name field */
	} obj$r_mhd_recsz_fields;
    } obj$r_mhd_recsz_overlay;
};

#endif	/*_OBJRECDEF_H*/
