/* <plvdef.h>
 *
 *	Privileged Library Vector definition
 */
#ifndef _PLVDEF_H
#define _PLVDEF_H

/* type codes for privilege vectors */
#define PLV$C_TYP_CMOD	1	/* change mode vector type */
#define PLV$C_TYP_MSG	2	/* message vector type */
struct plvdef {
    unsigned long plv$l_type;		/* type code for vector format */
    unsigned long plv$l_version;	/* system version number */
    union {
	unsigned long plv$l_kernel;	/* self-rel ptr to kernel mode dispatcher */
	unsigned long plv$l_msgdsp;	/* self-rel ptr to message dispatcher */
    } plv$r_kernel_overlay;
    unsigned long plv$l_exec;		/* self-rel ptr to exec mode dispatcher */
    unsigned long plv$l_usrundwn;	/* self-rel ptr to user rundown service */
    unsigned	: 32;			/* long fill; unused, reserved for future use */
    unsigned long plv$l_rms;		/* self-rel ptr to RMS services dispatcher */
    unsigned long plv$l_check;		/* longword used to check virtual */
					/* address location of vector	 */
};

#endif	/*_PLVDEF_H*/
