/* <pswdef.h>
 *
 *	Processor status word definitions (see also $PSLDEF)
 */
#ifndef _PSWDEF_H
#define _PSWDEF_H

#define PSW$V_C     0
#define PSW$V_V     1
#define PSW$V_Z     2
#define PSW$V_N     3
#define PSW$V_TBIT  4
#define PSW$V_IV    5
#define PSW$V_FU    6
#define PSW$V_DV    7
#define PSW$M_C     (1<<PSW$V_C)	/* 0x01 */
#define PSW$M_V     (1<<PSW$V_V)	/* 0x02 */
#define PSW$M_Z     (1<<PSW$V_Z)	/* 0x04 */
#define PSW$M_N     (1<<PSW$V_N)	/* 0x08 */
#define PSW$M_TBIT  (1<<PSW$V_TBIT)	/* 0x10 */
#define PSW$M_IV    (1<<PSW$V_IV)	/* 0x20 */
#define PSW$M_FU    (1<<PSW$V_FU)	/* 0x40 */
#define PSW$M_DV    (1<<PSW$V_DV)	/* 0x80 */
union pswdef {
    unsigned short psw$w_psw;		/* complete word */
    struct {
	unsigned psw$v_c    : 1;	/* carry */
	unsigned psw$v_v    : 1;	/* overflow */
	unsigned psw$v_z    : 1;	/* zero */
	unsigned psw$v_n    : 1;	/* negative */
	unsigned psw$v_tbit : 1;	/* trace trap enable */
	unsigned psw$v_iv   : 1;	/* integer overflow enable */
	unsigned psw$v_fu   : 1;	/* floating underflow enable */
	unsigned psw$v_dv   : 1;	/* decimal overflow enable */
	unsigned	    : 8;
    } psw$r_pswdef_bits;
};

#endif	/*_PSWDEF_H*/
