/* <shrdef.h>
 *
 *	Shared message/status codes
 */
#ifndef _SHRDEF_H
#define _SHRDEF_H

/*
   These message codes should not be used directly by a facility since
   they do not contain a subsystem (i.e., facility) identifier or a
   severity code.  Use the following formula to calculate actual facility
   message codes.
	facility_msg_code = ((facility_id << 16) | common_msg_code | severity)
 */
#define SHR$_FACILITY	0

#define SHR$_APPENDEDB	0x1000	/* 4096 */
#define SHR$_APPENDEDR	0x1008	/* 4104 */
#define SHR$_BADBYTE	0x1010	/* 4112 */
#define SHR$_BADFIELD	0x1018	/* 4120 */
#define SHR$_BADLONG	0x1020	/* 4128 */
#define SHR$_BADWORD	0x1028	/* 4136 */
#define SHR$_BEGIN	0x1030	/* 4144 */
#define SHR$_BEGIND	0x1038	/* 4152 */
#define SHR$_BEGINT	0x1040	/* 4160 */
#define SHR$_CLICB	0x1048	/* 4168 */
#define SHR$_CLOSEIN	0x1050	/* 4176 */
#define SHR$_CLOSEOUT	0x1058	/* 4184 */
#define SHR$_COPIEDB	0x1060	/* 4192 */
#define SHR$_COPIEDR	0x1068	/* 4200 */
#define SHR$_CREATED	0x1070	/* 4208 */
#define SHR$_ENDED	0x1078	/* 4216 */
#define SHR$_ENDEDD	0x1080	/* 4224 */
#define SHR$_ENDEDT	0x1088	/* 4232 */
#define SHR$_NEWFILES	0x1090	/* 4240 */
#define SHR$_OPENIN	0x1098	/* 4248 */
#define SHR$_OPENOUT	0x10A0	/* 4256 */
#define SHR$_OVERLAY	0x10A8	/* 4264 */
#define SHR$_READERR	0x10B0	/* 4272 */
#define SHR$_REPLACED	0x10B8	/* 4280 */
#define SHR$_WILDCONCAT 0x10C0	/* 4288 */
#define SHR$_WILDOUTVER 0x10C8	/* 4296 */
#define SHR$_WRITEERR	0x10D0	/* 4304 */
#define SHR$_ABEND	0x10D8	/* 4312 */
#define SHR$_ABENDD	0x10E0	/* 4320 */
#define SHR$_ABENDT	0x10E8	/* 4328 */
#define SHR$_SYSERRORPC 0x10F0	/* 4336 */
#define SHR$_SYNTAX	0x10F8	/* 4344 */
#define SHR$_NOVALUE	0x1100	/* 4352 */
#define SHR$_BADKEY	0x1108	/* 4360 */
#define SHR$_BADVALUE	0x1110	/* 4368 */
#define SHR$_BADDELIM	0x1118	/* 4376 */
#define SHR$_BADLOGIC	0x1120	/* 4384 */
#define SHR$_NOWILD	0x1128	/* 4392 */
#define SHR$_TEXT	0x1130	/* 4400 */
#define SHR$_IDXCONCAT	0x1138	/* 4408 */
#define SHR$_RELCONCAT	0x1140	/* 4416 */
#define SHR$_HIGHVER	0x1148	/* 4424 */
#define SHR$_BADLOGICPC 0x1150	/* 4432 */
#define SHR$_ATPC	0x1158	/* 4440 */
#define SHR$_BADCOPIES	0x1160	/* 4448 */
#define SHR$_BADFORM	0x1168	/* 4456 */
#define SHR$_BADJOBID	0x1170	/* 4464 */
#define SHR$_BADJOBNAME 0x1178	/* 4472 */
#define SHR$_BADPRTY	0x1180	/* 4480 */
#define SHR$_BADQNAME	0x1188	/* 4488 */
#define SHR$_BADTIME	0x1190	/* 4496 */
#define SHR$_NOQUEUE	0x1198	/* 4504 */
#define SHR$_NOJOBID	0x11A0	/* 4512 */
#define SHR$_NOJOBNAME	0x11A8	/* 4520 */
#define SHR$_SYSERROR	0x11B0	/* 4528 */
#define SHR$_NOTCOPIED	0x11B8	/* 4536 */
#define SHR$_NOTCMPLT	0x11C0	/* 4544 */
#define SHR$_RMSERROR	0x11C8	/* 4552 */
#define SHR$_UNXPCTSTS	0x11D0	/* 4560 */
#define SHR$_HASHCONCAT 0x11D8	/* 4568 */
#define SHR$_INCOMPAT	0x11E0	/* 4576 */
#define SHR$_VALERR	0x11E8	/* 4584 */
#define SHR$_FILNOTDEL	0x11F0	/* 4592 */
#define SHR$_CONFDEL	0x11F8	/* 4600 */
#define SHR$_DELETED	0x1200	/* 4608 */
#define SHR$_DELVER	0x1208	/* 4616 */
#define SHR$_PURGEVER	0x1210	/* 4624 */
#define SHR$_CLOSEDEL	0x1218	/* 4632 */
#define SHR$_DIRTOOBUS	0x1220	/* 4640 */
#define SHR$_NOFILPURG	0x1228	/* 4648 */
#define SHR$_FILNOTPUR	0x1230	/* 4656 */
#define SHR$_SEARCHFAIL 0x1238	/* 4664 */
#define SHR$_DELINTERR	0x1240	/* 4672 */
#define SHR$_PARSEFAIL	0x1248	/* 4680 */
#define SHR$_FILPURGED	0x1250	/* 4688 */
#define SHR$_ENDABORT	0x1258	/* 4696 */
#define SHR$_ENDDIAGS	0x1260	/* 4704 */
#define SHR$_ENDNOOBJ	0x1268	/* 4712 */
#define SHR$_HALTED	0x1270	/* 4720 */
#define SHR$_NOCMDMEM	0x1278	/* 4728 */
#define SHR$_QEMPTY	0x1280	/* 4736 */
#define SHR$_CBT	0x1288	/* 4744 */
#define SHR$_EXISTS	0x1290	/* 4752 */
#define SHR$_UNLOCKED	0x1298	/* 4760 */
#define SHR$_RENAMED	0x12A0	/* 4768 */
#define SHR$_PROTECTED	0x12A8	/* 4776 */
#define SHR$_NOTLOCKED	0x12B0	/* 4784 */
#define SHR$_ACTIMAGE	0x12B8	/* 4792 */
#define SHR$_DIRNOTCRE	0x12C0	/* 4800 */
#define SHR$_NODESTQUE	0x12C8	/* 4808 */
#define SHR$_ILLDESQUE	0x12D0	/* 4816 */
#define SHR$_NOTTERM	0x12D8	/* 4824 */
#define SHR$_CONFQUAL	0x12E0	/* 4832 */
#define SHR$_ILLDIRCOPY 0x12E8	/* 4840 */
#define SHR$_INSVIRMEM	0x12F0	/* 4848 */
#define SHR$_CREATEDSTM 0x12F8	/* 4856 */
#define SHR$_NOTRUNC	0x1300	/* 4864 */
#define SHR$_PRODNOTINS 0x1308	/* 4872 */
#define SHR$_TOTAL	0x1310	/* 4880 */
#define SHR$_FILPURG	0x1318	/* 4888 */
#define SHR$_FILDEL	0x1320	/* 4896 */
#define SHR$_INVQUAVAL	0x1328	/* 4904 */
#define SHR$_NOFILES	0x1330	/* 4912 */
#define SHR$_FILNOTACC	0x1338	/* 4920 */
#define SHR$_QUALMISS	0x1340	/* 4928 */
#define SHR$_FILSPCSRCH 0x1348	/* 4936 */
#define SHR$_NOSRCHLST	0x1350	/* 4944 */
#define SHR$_NOSUCHID	0x1358	/* 4952 */
#define SHR$_AMBIGANS	0x1360	/* 4960 */
#define SHR$_INVALANS	0x1368	/* 4968 */
#define SHR$_PRDCONT	0x1370	/* 4976 */
#define SHR$_NOTDELETED 0x1378	/* 4984 */
#define SHR$_NOMEANING	0x1380	/* 4992 */
#define SHR$_OPENERR	0x1388	/* 5000 */
#define SHR$_CLOSEERR	0x1390	/* 5008 */
#define SHR$_BADFORMAT	0x1398	/* 5016 */

#endif	/*_SHRDEF_H*/
