/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <str$routines.h>
 *
 *	String run-time library routines.
 */
#ifndef _STR$ROUTINES_H
#define _STR$ROUTINES_H
# ifdef __cplusplus
extern "C" {
# endif

/*	STR$ADD			-- add two decimal strings */
#define str$add STR$ADD
unsigned long str$add();
/*	STR$ANALYZE_SDESC	-- analyze string descriptor */
#define str$analyze_sdesc STR$ANALYZE_SDESC
unsigned short str$analyze_sdesc();
/*	STR$APPEND		-- append string */
#define str$append STR$APPEND
unsigned long str$append();
/*	STR$CASE_BLIND_COMPARE	-- compare strings without regard to case */
#define str$case_blind_compare STR$CASE_BLIND_COMPARE
int str$case_blind_compare();
/*	STR$COMPARE		-- compare two strings */
#define str$compare STR$COMPARE
int str$compare();
/*	STR$COMPARE_EQL		-- compare two strings for equality */
#define str$compare_eql STR$COMPARE_EQL
int str$compare_eql();
/*	STR$COMPARE_MULTI	-- compare two for equality using multinational character set */
#define str$compare_multi STR$COMPARE_MULTI
int str$compare_multi();
/*	STR$CONCAT		-- concatenate two or more strings */
#define str$concat STR$CONCAT
unsigned long str$concat();
/*	STR$COPY_DX		-- copy source passed by descriptor to destination */
#define str$copy_dx STR$COPY_DX
unsigned long str$copy_dx();
/*	STR$COPY_R		-- copy source passed by reference to destination */
#define str$copy_r STR$COPY_R
unsigned long str$copy_r();
/*	STR$DIVIDE		-- divide two decimal strings */
#define str$divide STR$DIVIDE
unsigned long str$divide();
/*	STR$DUPL_CHAR		-- duplicate character empty times */
#define str$dupl_char STR$DUPL_CHAR
unsigned long str$dupl_char();
/*	STR$ELEMENT		-- extract delimited element substring */
#define str$element STR$ELEMENT
unsigned long str$element();
/*	STR$FIND_FIRST_IN_SET	-- find first character in set of characters */
#define str$find_first_in_set STR$FIND_FIRST_IN_SET
int str$find_first_in_set();
/*	STR$FIND_FIRST_NOT_IN_SET -- find first that does not occur in set */
#define str$find_first_not_in_set STR$FIND_FIRST_NOT_IN_SET
int str$find_first_not_in_set();
/*	STR$FIND_FIRST_SUBSTRING -- find first substring in input string */
#define str$find_first_substring STR$FIND_FIRST_SUBSTRING
int str$find_first_substring();
/*	STR$FREE1_DX		-- free one dynamic string */
#define str$free1_dx STR$FREE1_DX
unsigned long str$free1_dx();
/*	STR$GET1_DX		-- allocate one dynamic string */
#define str$get1_dx STR$GET1_DX
unsigned long str$get1_dx();
/*	STR$LEFT		-- extract a substring of a string */
#define str$left STR$LEFT
unsigned long str$left();
/*	STR$LEN_EXTR		-- extract a substring of a string */
#define str$len_extr STR$LEN_EXTR
unsigned long str$len_extr();
/*	STR$MATCH_WILD		-- match wildcard specification */
#define str$match_wild STR$MATCH_WILD
unsigned long str$match_wild();
/*	STR$MUL			-- multiply two decimal strings */
#define str$mul STR$MUL
unsigned long str$mul();
/*	STR$POS_EXTR		-- extract a substring of a string */
#define str$pos_extr STR$POS_EXTR
unsigned long str$pos_extr();
/*	STR$POSITION		-- return relative position of substring */
#define str$position STR$POSITION
int str$position();
/*	STR$PREFIX		-- prefix a string */
#define str$prefix STR$PREFIX
unsigned long str$prefix();
/*	STR$RECIP		-- reciprocal of a decimal string */
#define str$recip STR$RECIP
unsigned long str$recip();
/*	STR$REPLACE		-- replace a substring */
#define str$replace STR$REPLACE
unsigned long str$replace();
/*	STR$RIGHT		-- extract a substring of a string */
#define str$right STR$RIGHT
unsigned long str$right();
/*	STR$ROUND		-- round or truncate a decimal string */
#define str$round STR$ROUND
unsigned long str$round();
/*	STR$TRANSLATE		-- translate matched characters */
#define str$translate STR$TRANSLATE
unsigned long str$translate();
/*	STR$TRIM		-- trim trailing blanks and tabs */
#define str$trim STR$TRIM
unsigned long str$trim();
/*	STR$UPCASE		-- convert string to all uppercase characters */
#define str$upcase STR$UPCASE
unsigned long str$upcase();

# ifdef __cplusplus
}
# endif
#endif	/*_STR$ROUTINES_H*/
