/* <strdef.h>
 *
 *	Message codes for STR$ library routines.
 */
#ifndef _STRDEF_H
#define _STRDEF_H

/*
   Symbols are defined following the standard for global names:
	STR$_ABCMNOXYZ
   In addition, the library standards specify that the letters "ABC", "MNO",
   and "XYZ" are the first three letters of the first three words of the error
   message, not counting articles and prepositions.
 */
#define STR$_FACILITY	36	/* 0x0024 */

/* The following severe errors are always signalled. */
#define STR$_FATINTERR		0x00248044	/* 2392132 */
#define STR$_DIVBY_ZER		0x0024804C	/* 2392140 */
#define STR$_ILLSTRCLA		0x00248054	/* 2392148 */
#define STR$_STRIS_INT		0x0024805C	/* 2392156 */
#define STR$_WRONUMARG		0x00248064	/* 2392164 */
#define STR$_INSVIRMEM		0x0024806C	/* 2392172 */
#define STR$_STRTOOLON		0x00248074	/* 2392180 */
#define STR$_ERRFREDYN		0x0024807C	/* 2392188 */

/* The following are warning errors. */
#define STR$_TRU		0x00248200	/* 2392576 */
#define STR$_NOMATCH		0x00248208	/* 2392584 */
#define STR$_INVDELIM		0x00248210	/* 2392592 */
#define STR$_NOELEM		0x00248218	/* 2392600 */

/* The following are qualified success messages. */
#define STR$_NEGSTRLEN		0x00248401	/* 2393089 */
#define STR$_ILLSTRPOS		0x00248409	/* 2393097 */
#define STR$_ILLSTRSPE		0x00248411	/* 2393105 */
#define STR$_MATCH		0x00248419	/* 2393113 */

/* Define STR$_NORMAL to be the same as SS$_NORMAL. */
#define STR$_NORMAL 1

#endif	/*_STRDEF_H*/
