/* <ttcdef.h>
 *
 *	Terminal character set definitions
 */
#ifndef _TTCDEF_H
#define _TTCDEF_H

#define TTC$V_KANA	8
#define TTC$V_KANJI	9
#define TTC$V_HANZI	10
#define TTC$V_HANGUL	11
#define TTC$V_HANYU	12
#define TTC$V_THAI	13
#define TTC$M_RESERCED	0x00FF
#define TTC$M_KANA	(1<<TTC$V_KANA)		/* 0x0100 */
#define TTC$M_KANJI	(1<<TTC$V_KANJI)	/* 0x0200 */
#define TTC$M_HANZI	(1<<TTC$V_HANZI)	/* 0x0400 */
#define TTC$M_HANGUL	(1<<TTC$V_HANGUL)	/* 0x0800 */
#define TTC$M_HANYU	(1<<TTC$V_HANYU)	/* 0x1000 */
#define TTC$M_THAI	(1<<TTC$V_THAI)		/* 0x2000 */
union ttcdef {
    struct {
	unsigned ttc$v_reserved : 8;	/* first byte is reserved */
	unsigned ttc$v_kana	: 1;	/* Katakana */
	unsigned ttc$v_kanji	: 1;	/* Kanji */
	unsigned ttc$v_hanzi	: 1;	/* Hanzi */
	unsigned ttc$v_hangul	: 1;	/* Hangul */
	unsigned ttc$v_hanyu	: 1;	/* Hanyu */
	unsigned ttc$v_thai	: 1;	/* Thai */
	unsigned		: 2;
    } ttc$r_ttcdef_bits;
};

#endif	/*_TTCDEF_H*/
