/* <vms/lib/vecdisdef.h>
 *
 *	LIB - VP_USE flags definitions		[not in Starlet]
 */
#ifndef _VECDISDEF_H
#define _VECDISDEF_H

/*
   Flags definitions for [$ENABLE|$DISABLE]_VP_USE services.
	Note: DEBUG understands the semantics of these flags.
 */
#define VECDIS$V_VALID_FLAGS	0
#define VECDIS$M_VALID_FLAGS	0x1F
#define VECDIS$S_VALID_FLAGS	5
#define VECDIS$V_ASYNC_HANDLER	0
#define VECDIS$V_DEBUG		1
#define VECDIS$V_PCA		2
#define VECDIS$V_ADA		3
#define VECDIS$V_VVIEF		4
#define VECDIS$M_ASYNC_HANDLER	(1<<VECDIS$V_ASYNC_HANDLER)	/* 0x01 */
#define VECDIS$M_DEBUG		(1<<VECDIS$V_DEBUG)		/* 0x02 */
#define VECDIS$M_PCA		(1<<VECDIS$V_PCA)		/* 0x04 */
#define VECDIS$M_ADA		(1<<VECDIS$V_ADA)		/* 0x08 */
#define VECDIS$M_VVIEF		(1<<VECDIS$V_VVIEF)		/* 0x10 */

#define VECDIS$S_VECDISDEF	1
union vecdisdef {
    unsigned char vecdis$b_flags;
    struct {
	unsigned vecdis$v_valid_flags : 5;
	unsigned		      : 3;	/* padding */
    } vecdis$r_valid_flags;
    struct {
	unsigned vecdis$v_async_handler : 1;	/* VMS async handlers */
	unsigned vecdis$v_debug : 1;		/* DEBUG */
	unsigned vecdis$v_pca	: 1;		/* PCA */
	unsigned vecdis$v_ada	: 1;		/* ADA */
	unsigned vecdis$v_vvief : 1;		/* VVIEF */
	unsigned		: 3;		/* padding */
    } vecdis$r_flags_bits;
};

#endif	/*_VECDISDEF_H*/
