/* <vpsrdef.h>
 *
 *	Vector Processor Status Register field definitions
 */
#ifndef _VPSRDEF_H
#define _VPSRDEF_H

#define VPSR$V_VEN	0
#define VPSR$V_RST	1
#define VPSR$V_STS	2
#define VPSR$V_RLD	3
#define VPSR$V_MF	5
#define VPSR$V_PMF	6
#define VPSR$V_AEX	7
#define VPSR$V_IMP	24
#define VPSR$V_IVO	25
#define VPSR$V_BSY	31
#define VPSR$M_VEN	(1<<VPSR$V_VEN)		/* 0x01 */
#define VPSR$M_RST	(1<<VPSR$V_RST)		/* 0x02 */
#define VPSR$M_STS	(1<<VPSR$V_STS)		/* 0x04 */
#define VPSR$M_RLD	(1<<VPSR$V_RLD)		/* 0x08 */
#define VPSR$M_MF	(1<<VPSR$V_MF)		/* 0x20 */
#define VPSR$M_PMF	(1<<VPSR$V_PMF)		/* 0x40 */
#define VPSR$M_AEX	(1<<VPSR$V_AEX)		/* 0x80 */
#define VPSR$M_IMP	(1<<VPSR$V_IMP)		/* 0x01000000 */
#define VPSR$M_IVO	(1<<VPSR$V_IVO)		/* 0x02000000 */
#define VPSR$M_BSY	(1<<VPSR$V_BSY)		/* 0x80000000 */
union vpsrdef {
    struct {
	unsigned vpsr$v_ven : 1;	/* enabled */
	unsigned vpsr$v_rst : 1;	/* reset */
	unsigned vpsr$v_sts : 1;	/* state store */
	unsigned vpsr$v_rld : 1;	/* state reload */
	unsigned	    : 1;	/* must be zero */
	unsigned vpsr$v_mf  : 1;	/* memory fault */
	unsigned vpsr$v_pmf : 1;	/* pending memory fault */
	unsigned vpsr$v_aex : 1;	/* arithmetic exception */
	unsigned	    : 16;	/* must be zero */
	unsigned vpsr$v_imp : 1;	/* implementation-specific error */
	unsigned vpsr$v_ivo : 1;	/* illegal vector opcode */
	unsigned	    : 5;	/* must be zero */
	unsigned vpsr$v_bsy : 1;	/* busy */
    } vpsr$r_vpsrdef_bits;
};

#endif	/*_VPSRDEF_H*/
